#include-once
;===========================================================================
; AutoIt implenentation by ProgAndy
; Author: ProgAndy
;===========================================================================
;#ifndef __CURL_CURL_H
;Global Const $__CURL_CURL_H
;/***************************************************************************
; *                                  _   _ ____  _
; *  Project                     ___| | | |  _ \| |
; *                             / __| | | | |_) | |
; *                            | (__| |_| |  _ <| |___
; *                             \___|\___/|_| \_\_____|
; *
; * Copyright (C) 1998 - 2009, Daniel Stenberg, <daniel@haxx.se>, et al.
; *
; * This software is licensed as described in the file COPYING, which
; * you should have received as part of this distribution. The terms
; * are also available at http://curl.haxx.se/docs/copyright.html.
; *
; * You may opt to use, copy, modify, merge, publish, distribute and/or sell
; * copies of the Software, and permit persons to whom the Software is
; * furnished to do so, under the terms of the COPYING file.
; *
; * This software is distributed on an "AS IS" basis, WITHOUT WARRANTY OF ANY
; * KIND, either express or implied.
; *
; * $Id: curl.h,v 1.390 2009-08-11 14:07:08 patrickm Exp $
; ***************************************************************************/

;/*
; * If you have libcurl problems, all docs and details are found here:
; *   http://curl.haxx.se/libcurl/
; *
; * curl-library mailing list subscription and unsubscription web interface:
; *   http://cool.haxx.se/mailman/listinfo/curl-library/
; */

#include "curlver.au3"         ;/* libcurl version defines  ; */
;#include "curl/curlbuild.h"  ;/* libcurl build definitions; */
;#include "curlrules.h"       ;/* libcurl rules enforcement; */
Global $ghLIBCURLdll=-1

Func _CURL_Load($DLLPath='')
	If $DLLPath<>'' Then ;adding search path for libcurl to %PATH%
		Local $path = EnvGet('PATH')
		If Not StringInStr(';'&$path&';',';'&$DLLPath&';')  Then
			EnvSet('PATH', $path&';' & $DLLPath)
			EnvUpdate()
		EndIf
	EndIf
	$ghLIBCURLdll = DllOpen('libcurl.dll')
	Return $ghLIBCURLdll<>-1
EndFunc

Global Const $curl_socket_t = "int" ;
Global Const $CURL_SOCKET_BAD = -1

Global Const $tagCURL_HTTPPOST = _
  "ptr next; " & _      ;/* next entry in the list; " & _*/ [curl_httppost*]
  "ptr name; " & _                      ;/* pointer to allocated name; " & _*/ [char*]
  "long namelength; " & _                 ;/* length of name length; " & _*/
  "ptr contents; " & _                  ;/* pointer to allocated data contents; " & _*/ [char*]
  "long contentslength; " & _             ;/* length of contents field; " & _*/
  "ptr buffer; " & _                    ;/* pointer to allocated buffer contents; " & _*/ [char*]
  "long bufferlength; " & _               ;/* length of buffer field; " & _*/
  "ptr contenttype; " & _               ;/* Content-Type; " & _*/ [char*]
  "ptr contentheader; " & _;/* list of extra headers for this form; " & _*/ [struct curl_slist* ]
  "ptr more; " & _      ;/* if one field name has more than one file, this link should link to following files; " & _*/ [struct curl_httppost*]
  "long flags; " & _                      ;/* as defined below; " & _*/
  "ptr showfilename; " & _              ;/* The file name to show. If not set, the actual file name will be used (if this is a file part); " & _*/ [char*]
  "ptr userp; "                      ;/* custom pointer used for HTTPPOST_CALLBACK posts; " & _*/
;};

Global Const $HTTPPOST_FILENAME = BitShift(1,0)    ;/* specified content is a file name; */
Global Const $HTTPPOST_READFILE = BitShift(1, -1)    ;/* specified content is a file name; */
Global Const $HTTPPOST_PTRNAME = BitShift(1, -2)     ;/* name is only stored pointer
                                       ; do not free in formfree; */
Global Const $HTTPPOST_PTRCONTENTS = BitShift(1, -3) ;/* contents is only stored pointer
                                       ; do not free in formfree; */
Global Const $HTTPPOST_BUFFER = BitShift(1, -4)      ;/* upload file from buffer; */
Global Const $HTTPPOST_PTRBUFFER = BitShift(1, -5)   ;/* upload file from pointer contents; */
Global Const $HTTPPOST_CALLBACK = BitShift(1, -6)    ;/* upload file contents by using the
                                       ; regular read callback to get the data
                                       ; and pass the given pointer as custom
                                       ; pointer; */

#cs
typedef int (*curl_progress_callback)(void *clientp,
                                      double dltotal,
                                      double dlnow,
                                      double ultotal,
                                      double ulnow);
#ce
Func _CURL_Progress_Callback_Register($Function)
	Return DllCallbackRegister($Function, "int:cdecl", "pre;double;double;double;double")
EndFunc
Func _curl_progress_callback($clientp, $dltotal, $dlnow, $ultotal, $ulnow)
	; exmample callback function
	ConsoleWrite( "------------------------------------" & @CRLF & "> _curl_progress_callback" & _
		"ClientP: " & $clientp & @CRLF & _
		"Download total (dltotal): " & $dltotal & @CRLF & _
		"Download now (dlnow): " & $dlnow & @CRLF & _
		"Upload total (ultotal): " & $ultotal & @CRLF & _
		"Upload now (ulnow): " & $ulnow & @CRLF & _
		'')
EndFunc

; #ifndef CURL_MAX_WRITE_SIZE
  ;/* Tests have proven that 20K is a very bad buffer size for uploads on
  ;   Windows, while 16K for some odd reason performed a lot better.
  ;   We do the ifndef check to allow this value to easier be changed at build
  ;   time for those who feel adventurous.; */
Global Const $CURL_MAX_WRITE_SIZE = 16384
;#endif
;/* This is a magic return code for the write callback that, when returned,
;   will signal libcurl to pause receiving on the current transfer.; */
Global Const $CURL_WRITEFUNC_PAUSE= 0x10000001
#cs
typedef size_t (*curl_write_callback)(char *buffer,
                                      size_t size,
                                      size_t nitems,
                                      void *outstream);
#ce
Func _CURL_Write_Callback_Register($Function)
	Return DllCallbackRegister($Function, "uint:cdecl", "ptr;uint;uint;ptr")
EndFunc
Func _curl_write_callback($buffer, $size, $nitems, $outstream)
	; exmample callback function
	ConsoleWrite( "------------------------------------" & @CRLF & "> _curl_write_callback" & _
		"Buffer: " & $buffer		& @CRLF & _
		"size: " & $size & @CRLF & _
		"nitems: " & $nitems & @CRLF & _
		"outstream: " & $outstream & @CRLF & _
		'')
EndFunc

;/* These are the return codes for the seek callbacks; */
Global Const $CURL_SEEKFUNC_OK       = 0
Global Const $CURL_SEEKFUNC_FAIL     = 1 ;/* fail the entire transfer; */
Global Const $CURL_SEEKFUNC_CANTSEEK = 2 ;/* tell libcurl seeking can't be done, so
                                    ;libcurl might try other means instead; */
#cs
typedef int (*curl_seek_callback)(void *instream,
                                  curl_off_t offset,
                                  int origin); ;/* 'whence'; */
#ce
Func _CURL_seek_callback_register($Function)
	Return DllCallbackRegister($Function, "int:cdecl", "ptr;int;int")
EndFunc
Func _curl_seek_callback($instream, $offset, $origin)
	; exmample callback function
	ConsoleWrite( "------------------------------------" & @CRLF & "> _curl_seek_callback" & _
		"instream: " & $instream & @CRLF & _
		"offset: " & $offset & @CRLF & _
		"origin: " & $origin & @CRLF & _
		'')
EndFunc

;/* This is a return code for the read callback that, when returned, will
   ;signal libcurl to immediately abort the current transfer.; */
Global Const $CURL_READFUNC_ABORT = 0x10000000
;/* This is a return code for the read callback that, when returned, will
   ;signal libcurl to pause sending data on the current transfer.; */
Global Const $CURL_READFUNC_PAUSE = 0x10000001

#cs
typedef size_t (*curl_read_callback)(char *buffer,
                                      size_t size,
                                      size_t nitems,
                                      void *instream);
#ce
Func _CURL_read_callback_register($Function)
	Return DllCallbackRegister($Function, "uint:cdecl", "ptr;uint;uint;ptr")
EndFunc
Func _curl_read_callback($buffer, $size, $nitems, $instream)
	; exmample callback function
	ConsoleWrite( "------------------------------------" & @CRLF & "> _curl_read_callback" & _
		"Buffer: " & $buffer		& @CRLF & _
		"size: " & $size & @CRLF & _
		"nitems: " & $nitems & @CRLF & _
		"instream: " & $instream & @CRLF & _
		'')
EndFunc

Global enum  _
  $CURLSOCKTYPE_IPCXN, _ ;/* socket created for a specific IP connection; */
  $CURLSOCKTYPE_LAST   ;/* never use; */
;} curlsocktype;

#cs
typedef int (*curl_sockopt_callback)(void *clientp,
                                     curl_socket_t curlfd,
                                     curlsocktype purpose);
#ce
Func _CURL_sockopt_callback_register($Function)
	Return DllCallbackRegister($Function, "int:cdecl", "ptr;int;int")
EndFunc
Func _curl_sockopt_callback($clientp, $curlfd, $purpose)
	; exmample callback function
	ConsoleWrite( "------------------------------------" & @CRLF & "> _curl_read_callback" & _
		"clientp: " & $clientp		& @CRLF & _
		"curlfd: " & $curlfd		& @CRLF & _
		"purpose: " & $purpose		& @CRLF & _
		'')
EndFunc

Global Const $tagCURL_SOCKADDR = _
  "int family;" & _
  "int socktype;" & _
  "int protocol;" & _
  "uint addrlen;" & _ ;/* addrlen was a socklen_t type before 7.18.0 but it turned really ugly and painful on the systems that lack this type; */
  "ushort SAfamily;" & _
  "byte SAdata[14]"
  ;struct sockaddr addr;
;};

;~ typedef curl_socket_t
;~ (*curl_opensocket_callback)(void *clientp,
;~                             curlsocktype purpose,
;~                             struct curl_sockaddr *address);
Func _CURL_Opensocket_Callback_Register($Function)
	Return DllCallbackRegister($Function, "int:cdecl", "ptr;int;ptr")
EndFunc
Func _curl_opensocket_callback($clientp, $purpose, $address)
	; exmample callback function
	ConsoleWrite( "------------------------------------" & @CRLF & "> _curl_write_callback" & @CRLF & _
		"ClientP: " & $clientp		& @CRLF & _
		"purpose: " & $purpose & @CRLF & _
		"address: " & $address & @CRLF & _
		'')
EndFunc

Global enum _ ;{
  $CURLIOE_OK, _             ;/* I/O operation successful; */
  $CURLIOE_UNKNOWNCMD, _     ;/* command was unknown to callback; */
  $CURLIOE_FAILRESTART, _    ;/* failed to restart the read; */
  $CURLIOE_LAST              ;/* never use; */
;} curlioerr;

Global enum  _
  $CURLIOCMD_NOP, _         ;/* no operation; */
  $CURLIOCMD_RESTARTREAD, _ ;/* restart the read stream from start; */
  $CURLIOCMD_LAST           ;/* never use; */
;} curliocmd;

;~ typedef curlioerr (*curl_ioctl_callback)(CURL *handle,
;~                                          int cmd,
;~                                          void *clientp);
Func _curl_ioctl_callback_Register($Function)
	Return DllCallbackRegister($Function, "int:cdecl", "ptr;int;ptr")
EndFunc
Func _curl_ioctl_callback($handle, $cmd, $clientp)
	; exmample callback function
	ConsoleWrite( "------------------------------------" & @CRLF & "> _curl_write_callback" & @CRLF & _
		"handle: " & $handle		& @CRLF & _
		"cmd: " & $cmd		& @CRLF & _
		"ClientP: " & $clientp		& @CRLF & _
		'')
EndFunc

;/*
; * The following typedef's are signatures of malloc, free, realloc, strdup and
; * calloc respectively.  Function pointers of these types can be passed to the
; * curl_global_init_mem() function to set user defined memory management
; * callback routines.
; */
#cs
typedef void *(*curl_malloc_callback)(size_t size);
typedef void (*curl_free_callback)(void *ptr);
typedef void *(*curl_realloc_callback)(void *ptr, size_t size);
typedef char *(*curl_strdup_callback)(const char *str);
typedef void *(*curl_calloc_callback)(size_t nmemb, size_t size);
#ce

;/* the kind of data that is passed to information_callback*/
Global enum _ ;{
  $CURLINFO_TEXT = 0, _
  $CURLINFO_HEADER_IN, _    ;/* 1; */
  $CURLINFO_HEADER_OUT, _   ;/* 2; */
  $CURLINFO_DATA_IN, _      ;/* 3; */
  $CURLINFO_DATA_OUT, _     ;/* 4; */
  $CURLINFO_SSL_DATA_IN, _  ;/* 5; */
  $CURLINFO_SSL_DATA_OUT, _ ;/* 6; */
  $CURLINFO_END
;} curl_infotype;

;~ typedef int (*curl_debug_callback)
;~        (CURL *handle,      ;/* the handle/transfer this concerns; */
;~         curl_infotype type, ;/* what kind of data; */
;~         char *data,        ;/* points to the data; */
;~         size_t size,       ;/* size of the data pointed to; */
;~         void *userptr);    ;/* whatever the user please; */
Func _curl_debug_callback_Register($Function)
	Return DllCallbackRegister($Function, "int:cdecl", "ptr;int;ptr;uint;ptr")
EndFunc
Func _curl_debug_callback($handle, $type, $data, $size, $userptr)
	; exmample callback function
	ConsoleWrite( "------------------------------------" & @CRLF & "> _curl_write_callback" & @CRLF & _
		"handle: " & $handle		& @CRLF & _
		"type: " & $type		& @CRLF & _
		"data: " & $data		& @CRLF & _
		"size: " & $size		& @CRLF & _
		"userptr: " & $userptr		& @CRLF & _
		'')
EndFunc

#cs
;/* All possible error codes from all sorts of curl functions. Future versions
   may return other values, stay prepared.

   Always add new return codes last. Never; *EVER* remove any. The return
   codes must remain the same!
; */
#ce

Global enum _ ;{
  $CURLE_OK = 0, _
  $CURLE_UNSUPPORTED_PROTOCOL, _    ;/* 1; */
  $CURLE_FAILED_INIT, _             ;/* 2; */
  $CURLE_URL_MALFORMAT, _           ;/* 3; */
  $CURLE_OBSOLETE4, _               ;/* 4 - NOT USED; */
  $CURLE_COULDNT_RESOLVE_PROXY, _   ;/* 5; */
  $CURLE_COULDNT_RESOLVE_HOST, _    ;/* 6; */
  $CURLE_COULDNT_CONNECT, _         ;/* 7; */
  $CURLE_FTP_WEIRD_SERVER_REPLY, _  ;/* 8; */
  $CURLE_REMOTE_ACCESS_DENIED, _    ;/* 9 a service was denied by the server due to lack of access - when login fails this is not returned.; */
  $CURLE_OBSOLETE10, _              ;/* 10 - NOT USED; */
  $CURLE_FTP_WEIRD_PASS_REPLY, _    ;/* 11; */
  $CURLE_OBSOLETE12, _              ;/* 12 - NOT USED; */
  $CURLE_FTP_WEIRD_PASV_REPLY, _    ;/* 13; */
  $CURLE_FTP_WEIRD_227_FORMAT, _    ;/* 14; */
  $CURLE_FTP_CANT_GET_HOST, _       ;/* 15; */
  $CURLE_OBSOLETE16, _              ;/* 16 - NOT USED; */
  $CURLE_FTP_COULDNT_SET_TYPE, _    ;/* 17; */
  $CURLE_PARTIAL_FILE, _            ;/* 18; */
  $CURLE_FTP_COULDNT_RETR_FILE, _   ;/* 19; */
  $CURLE_OBSOLETE20, _              ;/* 20 - NOT USED; */
  $CURLE_QUOTE_ERROR, _             ;/* 21 - quote command failure; */
  $CURLE_HTTP_RETURNED_ERROR, _     ;/* 22; */
  $CURLE_WRITE_ERROR, _             ;/* 23; */
  $CURLE_OBSOLETE24, _              ;/* 24 - NOT USED; */
  $CURLE_UPLOAD_FAILED, _           ;/* 25 - failed upload "command"; */
  $CURLE_READ_ERROR, _              ;/* 26 - couldn't open/read from file; */
  $CURLE_OUT_OF_MEMORY, _           ;/* 27; */ ;/* Note: $CURLE_OUT_OF_MEMORY may sometimes indicate a conversion error instead of a memory allocation error if CURL_DOES_CONVERSIONS is defined
  $CURLE_OPERATION_TIMEDOUT, _      ;/* 28 - the timeout time was reached; */
  $CURLE_OBSOLETE29, _              ;/* 29 - NOT USED; */
  $CURLE_FTP_PORT_FAILED, _         ;/* 30 - FTP PORT operation failed; */
  $CURLE_FTP_COULDNT_USE_REST, _    ;/* 31 - the REST command failed; */
  $CURLE_OBSOLETE32, _              ;/* 32 - NOT USED; */
  $CURLE_RANGE_ERROR, _             ;/* 33 - RANGE "command" didn't work; */
  $CURLE_HTTP_POST_ERROR, _         ;/* 34; */
  $CURLE_SSL_CONNECT_ERROR, _       ;/* 35 - wrong when connecting with SSL; */
  $CURLE_BAD_DOWNLOAD_RESUME, _     ;/* 36 - couldn't resume download; */
  $CURLE_FILE_COULDNT_READ_FILE, _  ;/* 37; */
  $CURLE_LDAP_CANNOT_BIND, _        ;/* 38; */
  $CURLE_LDAP_SEARCH_FAILED, _      ;/* 39; */
  $CURLE_OBSOLETE40, _              ;/* 40 - NOT USED; */
  $CURLE_FUNCTION_NOT_FOUND, _      ;/* 41; */
  $CURLE_ABORTED_BY_CALLBACK, _     ;/* 42; */
  $CURLE_BAD_FUNCTION_ARGUMENT, _   ;/* 43; */
  $CURLE_OBSOLETE44, _              ;/* 44 - NOT USED; */
  $CURLE_INTERFACE_FAILED, _        ;/* 45 - CURLOPT_INTERFACE failed; */
  $CURLE_OBSOLETE46, _              ;/* 46 - NOT USED; */
  $CURLE_TOO_MANY_REDIRECTS , _     ;/* 47 - catch endless re-direct loops; */
  $CURLE_UNKNOWN_TELNET_OPTION, _   ;/* 48 - User specified an unknown option; */
  $CURLE_TELNET_OPTION_SYNTAX , _   ;/* 49 - Malformed telnet option; */
  $CURLE_OBSOLETE50, _              ;/* 50 - NOT USED; */
  $CURLE_PEER_FAILED_VERIFICATION, _ ;/* 51 - peer's certificate or fingerprint wasn't verified fine; */
  $CURLE_GOT_NOTHING, _             ;/* 52 - when this is a specific error; */
  $CURLE_SSL_ENGINE_NOTFOUND, _     ;/* 53 - SSL crypto engine not found; */
  $CURLE_SSL_ENGINE_SETFAILED, _    ;/* 54 - can not set SSL crypto engine as default; */
  $CURLE_SEND_ERROR, _              ;/* 55 - failed sending network data; */
  $CURLE_RECV_ERROR, _              ;/* 56 - failure in receiving network data; */
  $CURLE_OBSOLETE57, _              ;/* 57 - NOT IN USE; */
  $CURLE_SSL_CERTPROBLEM, _         ;/* 58 - problem with the local certificate; */
  $CURLE_SSL_CIPHER, _              ;/* 59 - couldn't use specified cipher; */
  $CURLE_SSL_CACERT, _              ;/* 60 - problem with the CA cert (path?); */
  $CURLE_BAD_CONTENT_ENCODING, _    ;/* 61 - Unrecognized transfer encoding; */
  $CURLE_LDAP_INVALID_URL, _        ;/* 62 - Invalid LDAP URL; */
  $CURLE_FILESIZE_EXCEEDED, _       ;/* 63 - Maximum file size exceeded; */
  $CURLE_USE_SSL_FAILED, _          ;/* 64 - Requested FTP SSL level failed; */
  $CURLE_SEND_FAIL_REWIND, _        ;/* 65 - Sending the data requires a rewind that failed; */
  $CURLE_SSL_ENGINE_INITFAILED, _   ;/* 66 - failed to initialise ENGINE; */
  $CURLE_LOGIN_DENIED, _            ;/* 67 - user, _ password or similar was not accepted and we failed to login; */
  $CURLE_TFTP_NOTFOUND, _           ;/* 68 - file not found on server; */
  $CURLE_TFTP_PERM, _               ;/* 69 - permission problem on server; */
  $CURLE_REMOTE_DISK_FULL, _        ;/* 70 - out of disk space on server; */
  $CURLE_TFTP_ILLEGAL, _            ;/* 71 - Illegal TFTP operation; */
  $CURLE_TFTP_UNKNOWNID, _          ;/* 72 - Unknown transfer ID; */
  $CURLE_REMOTE_FILE_EXISTS, _      ;/* 73 - File already exists; */
  $CURLE_TFTP_NOSUCHUSER, _         ;/* 74 - No such user; */
  $CURLE_CONV_FAILED, _             ;/* 75 - conversion failed; */
  $CURLE_CONV_REQD, _               ;/* 76 - caller must register conversion callbacks using curl_easy_setopt options CURLOPT_CONV_FROM_NETWORK_FUNCTION, CURLOPT_CONV_TO_NETWORK_FUNCTION, _ and CURLOPT_CONV_FROM_UTF8_FUNCTION; */
  $CURLE_SSL_CACERT_BADFILE, _      ;/* 77 - could not load CACERT file, _ missing or wrong format; */
  $CURLE_REMOTE_FILE_NOT_FOUND, _   ;/* 78 - remote file not found; */
  $CURLE_SSH, _                     ;/* 79 - error from the SSH layer, _ somewhat generic so the error message will be of interest when this has happened; */
  $CURLE_SSL_SHUTDOWN_FAILED, _     ;/* 80 - Failed to shut down the SSL connection; */
  $CURLE_AGAIN, _                   ;/* 81 - socket is not ready for send/recv, wait till it's ready and try again (Added in 7.18.2); */
  $CURLE_SSL_CRL_BADFILE, _         ;/* 82 - could not load CRL file, _ missing or wrong format (Added in 7.19.0); */
  $CURLE_SSL_ISSUER_ERROR, _        ;/* 83 - Issuer check failed.  (Added in 7.19.0); */
  $CURL_LAST ;/* never use!; */
;} CURLcode;


;/* This prototype applies to all conversion callbacks; */
;~ typedef CURLcode (*curl_conv_callback)(char *buffer, size_t length);
Func _curl_conv_callback_Register($Function)
	Return DllCallbackRegister($Function, "int:cdecl", "ptr;uint")
EndFunc
Func _curl_conv_callback($buffer, $length)
	; exmample callback function
	ConsoleWrite( "------------------------------------" & @CRLF & "> _curl_conv_callback" & @CRLF & _
		"buffer: " & $buffer		& @CRLF & _
		"length: " & $length		& @CRLF & _
		'')
EndFunc

;~ typedef CURLcode (*curl_ssl_ctx_callback)(CURL *curl,    ;/* easy handle; */
;~                                           void *ssl_ctx, ;/* actually an
;~                                                             OpenSSL SSL_CTX; */
;~                                           void *userptr);
Func _curl_ssl_ctx_callback_Register($Function)
	Return DllCallbackRegister($Function, "int:cdecl", "ptr;ptr;ptr")
EndFunc
Func _curl_ssl_ctx_callback($curl, $ssl_ctx, $userptr)
	; exmample callback function
	ConsoleWrite( "------------------------------------" & @CRLF & "> _curl_conv_callback" & @CRLF & _
		"curl: " & $curl		& @CRLF & _
		"ssl_ctx: " & $ssl_ctx		& @CRLF & _
		"userptr: " & $userptr		& @CRLF & _
		'')
EndFunc

Global enum _ ;{
  $CURLPROXY_HTTP = 0, _   ;/* added in 7.10, new in 7.19.4 default is to use CONNECT HTTP/1.1; */
  $CURLPROXY_HTTP_1_0 = 1, _    ;/* added in 7.19.4, force to use CONNECT HTTP/1.0 ; */
  $CURLPROXY_SOCKS4 = 4, _  ;/* support added in 7.15.2, enum existed already in 7.10; */
  $CURLPROXY_SOCKS5 = 5, _  ;/* added in 7.10; */
  $CURLPROXY_SOCKS4A = 6, _  ;/* added in 7.18.0; */
  $CURLPROXY_SOCKS5_HOSTNAME = 7 ;/* Use the SOCKS5 protocol but pass along the host name rather than the IP address. added in 7.18.0; */
;} curl_proxytype;  ;/* this enum was added in 7.10; */

Global Const $CURLAUTH_NONE         = 0       ;/* nothing; */
Global Const $CURLAUTH_BASIC        = BitShift(1, -0)  ;/* Basic = BitShift(default); */
Global Const $CURLAUTH_DIGEST       = BitShift(1, -1)  ;/* Digest; */
Global Const $CURLAUTH_GSSNEGOTIATE = BitShift(1, -2)  ;/* GSS-Negotiate; */
Global Const $CURLAUTH_NTLM         = BitShift(1, -3)  ;/* NTLM; */
Global Const $CURLAUTH_DIGEST_IE    = BitShift(1, -4)  ;/* Digest with IE flavour; */
Global Const $CURLAUTH_ANY = BitNOT($CURLAUTH_DIGEST_IE)  ;/* all fine types set; */
Global Const $CURLAUTH_ANYSAFE = BitNOT(BitOR($CURLAUTH_BASIC,$CURLAUTH_DIGEST_IE))

Global Const $CURLSSH_AUTH_ANY       = BitNOT(0)     ;/* all types supported by the server; */
Global Const $CURLSSH_AUTH_NONE      = 0      ;/* none allowed, silly but complete; */
Global Const $CURLSSH_AUTH_PUBLICKEY = BitShift(1, -0) ;/* public/private key files; */
Global Const $CURLSSH_AUTH_PASSWORD  = BitShift(1, -1) ;/* password; */
Global Const $CURLSSH_AUTH_HOST      = BitShift(1, -2) ;/* host key files; */
Global Const $CURLSSH_AUTH_KEYBOARD  = BitShift(1, -3) ;/* keyboard interactive; */
Global Const $CURLSSH_AUTH_DEFAULT = $CURLSSH_AUTH_ANY

Global Const $CURL_ERROR_SIZE = 256

Global Const $tagCURL_KHKEY = _
  "ptr key;" & _ ;/* points to a zero-terminated string encoded with base64 if len is zero, otherwise to the "raw" data; */
  "uint len;" & _
  "dword keytype;"
;};
Global enum _ ;type {
    $CURLKHTYPE_UNKNOWN, _
    $CURLKHTYPE_RSA1, _
    $CURLKHTYPE_RSA, _
    $CURLKHTYPE_DSS
;  } keytype;

;/* this is the set of return values expected from the curl_sshkeycallback callback; */
Global enum _ ;curl_khstat {
  $CURLKHSTAT_FINE_ADD_TO_FILE, _
  $CURLKHSTAT_FINE, _
  $CURLKHSTAT_REJECT, _ ;/* reject the connection, return an error; */
  $CURLKHSTAT_DEFER, _  ;/* do not accept it, but we can't answer right now so this causes a CURLE_DEFER error but otherwise the connection will be left intact etc; */
  $CURLKHSTAT_LAST    ;/* not for use, only a marker for last-in-list; */
;};

;/* this is the set of status codes pass in to the callback; */
Global enum _ ;curl_khmatch {
  $CURLKHMATCH_OK, _       ;/* match; */
  $CURLKHMATCH_MISMATCH, _ ;/* host found, key mismatch!; */
  $CURLKHMATCH_MISSING, _  ;/* no matching host/key found; */
  $CURLKHMATCH_LAST      ;/* not for use, only a marker for last-in-list; */
;};

;~ typedef int
;~   (*curl_sshkeycallback) (CURL *easy,     ;/* easy handle; */
;~                           const struct curl_khkey *knownkey, ;/* known; */
;~                           const struct curl_khkey *foundkey, ;/* found; */
;~                           enum curl_khmatch, ;/* libcurl's view on the keys; */
;~                           void *clientp); ;/* custom pointer passed from app; */
Func _curl_sshkeycallback_Register($Function)
	Return DllCallbackRegister($Function, "int:cdecl", "ptr;ptr;ptr;int;ptr")
EndFunc
Func _curl_sshkeycallback($easy, $knownkey, $foundkey, $curl_khmatch, $clientp)
	; exmample callback function
	ConsoleWrite( "------------------------------------" & @CRLF & "> _curl_sshkeycallback" & @CRLF & _
		"easy: " & $easy		& @CRLF & _
		"lnownkey: " & $knownkey		& @CRLF & _
		"foundkey: " & $foundkey		& @CRLF & _
		"curl_khmatch: " & $curl_khmatch		& @CRLF & _
		"clientp: " & $clientp		& @CRLF & _
		'')
EndFunc

;/* parameter for the CURLOPT_USE_SSL option; */
Global enum _ ;{
  $CURLUSESSL_NONE, _    ;/* do not attempt to use SSL; */
  $CURLUSESSL_TRY, _     ;/* try using SSL, proceed anyway otherwise; */
  $CURLUSESSL_CONTROL, _ ;/* SSL for the control connection or fail; */
  $CURLUSESSL_ALL, _     ;/* SSL for all communication or fail; */
  $CURLUSESSL_LAST     ;/* not an option, never use; */
;} curl_usessl;


;/* parameter for the CURLOPT_FTP_SSL_CCC option; */
Global enum _ ;{
  $CURLFTPSSL_CCC_NONE, _    ;/* do not send CCC; */
  $CURLFTPSSL_CCC_PASSIVE, _ ;/* Let the server initiate the shutdown; */
  $CURLFTPSSL_CCC_ACTIVE, _  ;/* Initiate the shutdown; */
  $CURLFTPSSL_CCC_LAST     ;/* not an option, never use; */
;} curl_ftpccc;

;/* parameter for the CURLOPT_FTPSSLAUTH option; */
Global enum _ ;{
  $CURLFTPAUTH_DEFAULT, _ ;/* let libcurl decide; */
  $CURLFTPAUTH_SSL, _     ;/* use "AUTH SSL"; */
  $CURLFTPAUTH_TLS, _     ;/* use "AUTH TLS"; */
  $CURLFTPAUTH_LAST ;/* not an option, never use; */
;} curl_ftpauth;

;/* parameter for the CURLOPT_FTP_CREATE_MISSING_DIRS option; */
Global enum _ ;{
  $CURLFTP_CREATE_DIR_NONE, _  ;/* do NOT create missing dirs!; */
  $CURLFTP_CREATE_DIR, _       ;/* (FTP/SFTP) if CWD fails, try MKD and then CWD again if MKD succeeded, for SFTP this does similar magic; */
  $CURLFTP_CREATE_DIR_RETRY, _ ;/* (FTP only) if CWD fails, try MKD and then CWD again even if MKD failed!; */
  $CURLFTP_CREATE_DIR_LAST   ;/* not an option, never use; */
;} curl_ftpcreatedir;

;/* parameter for the CURLOPT_FTP_FILEMETHOD option; */
Global enum _ ;{
  $CURLFTPMETHOD_DEFAULT, _   ;/* let libcurl pick; */
  $CURLFTPMETHOD_MULTICWD, _  ;/* single CWD operation for each path part; */
  $CURLFTPMETHOD_NOCWD, _     ;/* no CWD at all; */
  $CURLFTPMETHOD_SINGLECWD, _ ;/* one CWD to full dir, then work on file; */
  $CURLFTPMETHOD_LAST       ;/* not an option, never use; */
;} curl_ftpmethod;

;/* CURLPROTO_ defines are for the CURLOPT_*PROTOCOLS options; */
Global Const $CURLPROTO_HTTP   = BitShift(1, -0)
Global Const $CURLPROTO_HTTPS  = BitShift(1, -1)
Global Const $CURLPROTO_FTP    = BitShift(1, -2)
Global Const $CURLPROTO_FTPS   = BitShift(1, -3)
Global Const $CURLPROTO_SCP    = BitShift(1, -4)
Global Const $CURLPROTO_SFTP   = BitShift(1, -5)
Global Const $CURLPROTO_TELNET = BitShift(1, -6)
Global Const $CURLPROTO_LDAP   = BitShift(1, -7)
Global Const $CURLPROTO_LDAPS  = BitShift(1, -8)
Global Const $CURLPROTO_DICT   = BitShift(1, -9)
Global Const $CURLPROTO_FILE   = BitShift(1, -10)
Global Const $CURLPROTO_TFTP   = BitShift(1, -11)
Global Const $CURLPROTO_ALL    = BitNOT(0) ;/* enable everything; */

;/* long may be 32 or 64 bits, but we should never depend on anything else but 32; */
Global Const $CURLOPTTYPE_LONG          = 0
Global Const $CURLOPTTYPE_OBJECTPOINT   = 10000
Global Const $CURLOPTTYPE_FUNCTIONPOINT = 20000
Global Const $CURLOPTTYPE_OFF_T         = 30000

;/* name is uppercase CURLOPT_<name>,
;   type is one of the defined CURLOPTTYPE_<type>
;   number is unique identifier; */
;#ifdef CINIT
;#undef CINIT
;#endif

#cs
#ifdef CURL_ISOCPP
#define CINIT(name,type,number) CURLOPT_ ## name = CURLOPTTYPE_ ## type + number
#else
;/* The macro "##" is ISO C, we assume pre-ISO C doesn't support it.; */
#define LONG          CURLOPTTYPE_LONG
#define OBJECTPOINT   CURLOPTTYPE_OBJECTPOINT
#define FUNCTIONPOINT CURLOPTTYPE_FUNCTIONPOINT
#define OFF_T         CURLOPTTYPE_OFF_T
#define CINIT(name,type,number) CURLOPT_/**/name = type + number
#endif
#ce

;/*
; * This macro-mania below setups the CURLOPT_[what] enum, to be used with
; * curl_easy_setopt(). The first argument in the CINIT() macro is the [what]
; * word.
; */

;typedef enum {
  ;/* This is the FILE; * or void * the regular output should be written to.; */
  Global Const $CURLOPT_FILE = $CURLOPTTYPE_OBJECTPOINT + 1

  ;/* The full URL to get/put; */
  Global Const $CURLOPT_URL =  $CURLOPTTYPE_OBJECTPOINT + 2

  ;/* Port number to connect to = if other than default.; */
  Global Const $CURLOPT_PORT = $CURLOPTTYPE_LONG + 3

  ;/* Name of proxy to use.; */
  Global Const $CURLOPT_PROXY = $CURLOPTTYPE_OBJECTPOINT + 4

  ;/* "name:password" to use when fetching.; */
  Global Const $CURLOPT_USERPWD = $CURLOPTTYPE_OBJECTPOINT + 5

  ;/* "name:password" to use with proxy.; */
  Global Const $CURLOPT_PROXYUSERPWD = $CURLOPTTYPE_OBJECTPOINT + 6

  ;/* Range to get = specified as an ASCII string.; */
  Global Const $CURLOPT_RANGE = $CURLOPTTYPE_OBJECTPOINT + 7

  ;/* not used; */

  ;/* Specified file stream to upload from (use as input):; */
  Global Const $CURLOPT_INFILE = $CURLOPTTYPE_OBJECTPOINT + 9

  ;/* Buffer to receive error messages in = must be at least CURL_ERROR_SIZE
  ; * bytes big. If this is not used = error messages go to stderr instead:; */
  Global Const $CURLOPT_ERRORBUFFER = $CURLOPTTYPE_OBJECTPOINT + 10

  ;/* Function that will be called to store the output (instead of fwrite). The
  ; * parameters will use fwrite() syntax = make sure to follow them.; */
  Global Const $CURLOPT_WRITEFUNCTION = $CURLOPTTYPE_FUNCTIONPOINT + 11

  ;/* Function that will be called to read the input (instead of fread). The
  ; * parameters will use fread() syntax = make sure to follow them.; */
  Global Const $CURLOPT_READFUNCTION = $CURLOPTTYPE_FUNCTIONPOINT + 12

  ;/* Time-out the read operation after this amount of seconds; */
  Global Const $CURLOPT_TIMEOUT = $CURLOPTTYPE_LONG + 13

  ;/* If the CURLOPT_INFILE is used = this can be used to inform libcurl about
  ; * how large the file being sent really is. That allows better error
  ; * checking and better verifies that the upload was successful. -1 means
  ; * unknown size.
  ; *
  ; * For large file support = there is also a _LARGE version of the key
  ; * which takes an off_t type = allowing platforms with larger off_t
  ; * sizes to handle larger files.  See below for INFILESIZE_LARGE.
  ; */
  Global Const $CURLOPT_INFILESIZE = $CURLOPTTYPE_LONG + 14

  ;/* POST static input fields.; */
  Global Const $CURLOPT_POSTFIELDS = $CURLOPTTYPE_OBJECTPOINT + 15

  ;/* Set the referrer page (needed by some CGIs); */
  Global Const $CURLOPT_REFERER = $CURLOPTTYPE_OBJECTPOINT + 16

  ;/* Set the FTP PORT string (interface name = named or numerical IP address)
  ;   Use i.e '-' to use default address.; */
  Global Const $CURLOPT_FTPPORT = $CURLOPTTYPE_OBJECTPOINT + 17

  ;/* Set the User-Agent string (examined by some CGIs); */
  Global Const $CURLOPT_USERAGENT = $CURLOPTTYPE_OBJECTPOINT + 18

  ;/* If the download receives less than "low speed limit" bytes/second
  ; * during "low speed time" seconds = the operations is aborted.
  ; * You could i.e if you have a pretty high speed connection = abort if
  ; * it is less than 2000 bytes/sec during 20 seconds.
  ; */

  ;/* Set the "low speed limit"; */
  Global Const $CURLOPT_LOW_SPEED_LIMIT = $CURLOPTTYPE_LONG + 19

  ;/* Set the "low speed time"; */
  Global Const $CURLOPT_LOW_SPEED_TIME = $CURLOPTTYPE_LONG + 20

  ;/* Set the continuation offset.
  ; *
  ; * Note there is also a _LARGE version of this key which uses
  ; * off_t types = allowing for large file offsets on platforms which
  ; * use larger-than-32-bit off_t's.  Look below for RESUME_FROM_LARGE.
  ; */
  Global Const $CURLOPT_RESUME_FROM = $CURLOPTTYPE_LONG + 21

  ;/* Set cookie in request:; */
  Global Const $CURLOPT_COOKIE = $CURLOPTTYPE_OBJECTPOINT + 22

  ;/* This points to a linked list of headers, struct curl_slist kind; */
  Global Const $CURLOPT_HTTPHEADER= $CURLOPTTYPE_OBJECTPOINT +23

  ;/* This points to a linked list of post entries, struct curl_httppost; */
  Global Const $CURLOPT_HTTPPOST= $CURLOPTTYPE_OBJECTPOINT +24

  ;/* name of the file keeping your private SSL-certificate; */
  Global Const $CURLOPT_SSLCERT= $CURLOPTTYPE_OBJECTPOINT +25

  ;/* password for the SSL or SSH private key; */
  Global Const $CURLOPT_KEYPASSWD= $CURLOPTTYPE_OBJECTPOINT +26

  ;/* send TYPE parameter?; */
  Global Const $CURLOPT_CRLF= $CURLOPTTYPE_LONG +27

  ;/* send linked-list of QUOTE commands; */
  Global Const $CURLOPT_QUOTE= $CURLOPTTYPE_OBJECTPOINT +28

  ;/* send FILE; * or void * to store headers to, if you use a callback it
  ;   is simply passed to the callback unmodified; */
  Global Const $CURLOPT_WRITEHEADER= $CURLOPTTYPE_OBJECTPOINT +29

  ;/* point to a file to read the initial cookies from, also enables
  ;   "cookie awareness"; */
  Global Const $CURLOPT_COOKIEFILE= $CURLOPTTYPE_OBJECTPOINT +31

  ;/* What version to specifically try to use.
  ;   See CURL_SSLVERSION defines below.; */
  Global Const $CURLOPT_SSLVERSION= $CURLOPTTYPE_LONG +32

  ;/* What kind of HTTP time condition to use, see defines; */
  Global Const $CURLOPT_TIMECONDITION= $CURLOPTTYPE_LONG +33

  ;/* Time to use with the above condition. Specified in number of seconds
  ;   since 1 Jan 1970; */
  Global Const $CURLOPT_TIMEVALUE= $CURLOPTTYPE_LONG +34

  ;/* 35 = OBSOLETE; */

  ;/* Custom request, for customizing the get command like
  ;   HTTP: DELETE, TRACE and others
  ;   FTP: to use a different list command
  ; */
  Global Const $CURLOPT_CUSTOMREQUEST= $CURLOPTTYPE_OBJECTPOINT +36

  ;/* HTTP request, for odd commands like DELETE, TRACE and others; */
  Global Const $CURLOPT_STDERR= $CURLOPTTYPE_OBJECTPOINT +37

  ;/* 38 is not used; */

  ;/* send linked-list of post-transfer QUOTE commands; */
  Global Const $CURLOPT_POSTQUOTE= $CURLOPTTYPE_OBJECTPOINT +39

  ;/* Pass a pointer to string of the output using full variable-replacement
  ;   as described elsewhere.; */
  Global Const $CURLOPT_WRITEINFO= $CURLOPTTYPE_OBJECTPOINT +40

  Global Const $CURLOPT_VERBOSE= $CURLOPTTYPE_LONG +41      ;/* talk a lot; */
  Global Const $CURLOPT_HEADER= $CURLOPTTYPE_LONG +42       ;/* throw the header out too; */
  Global Const $CURLOPT_NOPROGRESS= $CURLOPTTYPE_LONG +43   ;/* shut off the progress meter; */
  Global Const $CURLOPT_NOBODY= $CURLOPTTYPE_LONG +44       ;/* use HEAD to get http document; */
  Global Const $CURLOPT_FAILONERROR= $CURLOPTTYPE_LONG +45  ;/* no output on http error codes >= 300; */
  Global Const $CURLOPT_UPLOAD= $CURLOPTTYPE_LONG +46       ;/* this is an upload; */
  Global Const $CURLOPT_POST= $CURLOPTTYPE_LONG +47         ;/* HTTP POST method; */
  Global Const $CURLOPT_DIRLISTONLY= $CURLOPTTYPE_LONG +48  ;/* return bare names when listing directories; */

  Global Const $CURLOPT_APPEND= $CURLOPTTYPE_LONG +50       ;/* Append instead of overwrite on upload!; */

  ;/* Specify whether to read the user+password from the .netrc or the URL.
  ; * This must be one of the CURL_NETRC_* enums below.; */
  Global Const $CURLOPT_NETRC= $CURLOPTTYPE_LONG +51

  Global Const $CURLOPT_FOLLOWLOCATION= $CURLOPTTYPE_LONG +52  ;/* use Location: Luke!; */

  Global Const $CURLOPT_TRANSFERTEXT= $CURLOPTTYPE_LONG +53 ;/* transfer data in text/ASCII format; */
  Global Const $CURLOPT_PUT= $CURLOPTTYPE_LONG +54          ;/* HTTP PUT; */

  ;/* 55 = OBSOLETE; */

  ;/* Function that will be called instead of the internal progress display
  ; * function. This function should be defined as the curl_progress_callback
  ; * prototype defines.; */
  Global Const $CURLOPT_PROGRESSFUNCTION= $CURLOPTTYPE_FUNCTIONPOINT +56

  ;/* Data passed to the progress callback; */
  Global Const $CURLOPT_PROGRESSDATA= $CURLOPTTYPE_OBJECTPOINT +57

  ;/* We want the referrer field set automatically when following locations; */
  Global Const $CURLOPT_AUTOREFERER= $CURLOPTTYPE_LONG +58

  ;/* Port of the proxy, can be set in the proxy string as well with:
  ;   "[host]:[port]"; */
  Global Const $CURLOPT_PROXYPORT= $CURLOPTTYPE_LONG +59

  ;/* size of the POST input data, if strlen() is not good to use; */
  Global Const $CURLOPT_POSTFIELDSIZE= $CURLOPTTYPE_LONG +60

  ;/* tunnel non-http operations through a HTTP proxy; */
  Global Const $CURLOPT_HTTPPROXYTUNNEL= $CURLOPTTYPE_LONG +61

  ;/* Set the interface string to use as outgoing network interface; */
  Global Const $CURLOPT_INTERFACE= $CURLOPTTYPE_OBJECTPOINT +62

  ;/* Set the krb4/5 security level, this also enables krb4/5 awareness.  This
  ; * is a string, 'clear', 'safe', 'confidential' or 'private'.  If the string
  ; * is set but doesn't match one of these, 'private' will be used. ; */
  Global Const $CURLOPT_KRBLEVEL= $CURLOPTTYPE_OBJECTPOINT +63

  ;/* Set if we should verify the peer in ssl handshake, set 1 to verify.; */
  Global Const $CURLOPT_SSL_VERIFYPEER= $CURLOPTTYPE_LONG +64

  ;/* The CApath or CAfile used to validate the peer certificate
  ;   this option is used only if SSL_VERIFYPEER is true; */
  Global Const $CURLOPT_CAINFO= $CURLOPTTYPE_OBJECTPOINT +65

  ;/* 66 = OBSOLETE; */
  ;/* 67 = OBSOLETE; */

  ;/* Maximum number of http redirects to follow; */
  Global Const $CURLOPT_MAXREDIRS= $CURLOPTTYPE_LONG +68

  ;/* Pass a long set to 1 to get the date of the requested document (if
  ;   possible)! Pass a zero to shut it off.; */
  Global Const $CURLOPT_FILETIME= $CURLOPTTYPE_LONG +69

  ;/* This points to a linked list of telnet options; */
  Global Const $CURLOPT_TELNETOPTIONS= $CURLOPTTYPE_OBJECTPOINT +70

  ;/* Max amount of cached alive connections; */
  Global Const $CURLOPT_MAXCONNECTS= $CURLOPTTYPE_LONG +71

  ;/* What policy to use when closing connections when the cache is filled
  ;   up; */
  Global Const $CURLOPT_CLOSEPOLICY= $CURLOPTTYPE_LONG +72

  ;/* 73 = OBSOLETE; */

  ;/* Set to explicitly use a new connection for the upcoming transfer.
  ;   Do not use this unless you're absolutely sure of this, as it makes the
  ;   operation slower and is less friendly for the network.; */
  Global Const $CURLOPT_FRESH_CONNECT= $CURLOPTTYPE_LONG +74

  ;/* Set to explicitly forbid the upcoming transfer's connection to be re-used
  ;   when done. Do not use this unless you're absolutely sure of this, as it
  ;   makes the operation slower and is less friendly for the network.; */
  Global Const $CURLOPT_FORBID_REUSE= $CURLOPTTYPE_LONG +75

  ;/* Set to a file name that contains random data for libcurl to use to
  ;   seed the random engine when doing SSL connects.; */
  Global Const $CURLOPT_RANDOM_FILE= $CURLOPTTYPE_OBJECTPOINT +76

  ;/* Set to the Entropy Gathering Daemon socket pathname; */
  Global Const $CURLOPT_EGDSOCKET= $CURLOPTTYPE_OBJECTPOINT +77

  ;/* Time-out connect operations after this amount of seconds, if connects
  ;   are OK within this time, then fine... This only aborts the connect
  ;   phase. [Only works on unix-style/SIGALRM operating systems]; */
  Global Const $CURLOPT_CONNECTTIMEOUT= $CURLOPTTYPE_LONG +78

  ;/* Function that will be called to store headers (instead of fwrite). The
  ; * parameters will use fwrite() syntax, make sure to follow them.; */
  Global Const $CURLOPT_HEADERFUNCTION= $CURLOPTTYPE_FUNCTIONPOINT +79

  ;/* Set this to force the HTTP request to get back to GET. Only really usable
  ;   if POST, PUT or a custom request have been used first.
  ; */
  Global Const $CURLOPT_HTTPGET= $CURLOPTTYPE_LONG +80

  ;/* Set if we should verify the Common name from the peer certificate in ssl
  ; * handshake, set 1 to check existence, 2 to ensure that it matches the
  ; * provided hostname.; */
  Global Const $CURLOPT_SSL_VERIFYHOST= $CURLOPTTYPE_LONG +81

  ;/* Specify which file name to write all known cookies in after completed
  ;   operation. Set file name to "-" (dash) to make it go to stdout.; */
  Global Const $CURLOPT_COOKIEJAR= $CURLOPTTYPE_OBJECTPOINT +82

  ;/* Specify which SSL ciphers to use; */
  Global Const $CURLOPT_SSL_CIPHER_LIST= $CURLOPTTYPE_OBJECTPOINT +83

  ;/* Specify which HTTP version to use! This must be set to one of the
  ;   CURL_HTTP_VERSION* enums set below.; */
  Global Const $CURLOPT_HTTP_VERSION= $CURLOPTTYPE_LONG +84

  ;/* Specifically switch on or off the FTP engine's use of the EPSV command. By
  ;   default, that one will always be attempted before the more traditional
  ;   PASV command.; */
  Global Const $CURLOPT_FTP_USE_EPSV= $CURLOPTTYPE_LONG +85

  ;/* type of the file keeping your SSL-certificate ("DER", "PEM", "ENG"); */
  Global Const $CURLOPT_SSLCERTTYPE= $CURLOPTTYPE_OBJECTPOINT +86

  ;/* name of the file keeping your private SSL-key; */
  Global Const $CURLOPT_SSLKEY= $CURLOPTTYPE_OBJECTPOINT +87

  ;/* type of the file keeping your private SSL-key ("DER", "PEM", "ENG"); */
  Global Const $CURLOPT_SSLKEYTYPE= $CURLOPTTYPE_OBJECTPOINT +88

  ;/* crypto engine for the SSL-sub system; */
  Global Const $CURLOPT_SSLENGINE= $CURLOPTTYPE_OBJECTPOINT +89

  ;/* set the crypto engine for the SSL-sub system as default
  ;   the param has no meaning...
  ; */
  Global Const $CURLOPT_SSLENGINE_DEFAULT= $CURLOPTTYPE_LONG +90

  ;/* Non-zero value means to use the global dns cache; */
  Global Const $CURLOPT_DNS_USE_GLOBAL_CACHE= $CURLOPTTYPE_LONG +91 ;/* To become OBSOLETE soon; */

  ;/* DNS cache timeout; */
  Global Const $CURLOPT_DNS_CACHE_TIMEOUT= $CURLOPTTYPE_LONG +92

  ;/* send linked-list of pre-transfer QUOTE commands; */
  Global Const $CURLOPT_PREQUOTE= $CURLOPTTYPE_OBJECTPOINT +93

  ;/* set the debug function; */
  Global Const $CURLOPT_DEBUGFUNCTION= $CURLOPTTYPE_FUNCTIONPOINT +94

  ;/* set the data for the debug function; */
  Global Const $CURLOPT_DEBUGDATA= $CURLOPTTYPE_OBJECTPOINT +95

  ;/* mark this as start of a cookie session; */
  Global Const $CURLOPT_COOKIESESSION= $CURLOPTTYPE_LONG +96

  ;/* The CApath directory used to validate the peer certificate
  ;   this option is used only if SSL_VERIFYPEER is true; */
  Global Const $CURLOPT_CAPATH= $CURLOPTTYPE_OBJECTPOINT +97

  ;/* Instruct libcurl to use a smaller receive buffer; */
  Global Const $CURLOPT_BUFFERSIZE= $CURLOPTTYPE_LONG +98

  ;/* Instruct libcurl to not use any signal/alarm handlers, even when using
  ;   timeouts. This option is useful for multi-threaded applications.
  ;   See libcurl-the-guide for more background information.; */
  Global Const $CURLOPT_NOSIGNAL= $CURLOPTTYPE_LONG +99

  ;/* Provide a CURLShare for mutexing non-ts data; */
  Global Const $CURLOPT_SHARE= $CURLOPTTYPE_OBJECTPOINT +100

  ;/* indicates type of proxy. accepted values are CURLPROXY_HTTP (default
  ;   CURLPROXY_SOCKS4, CURLPROXY_SOCKS4A and CURLPROXY_SOCKS5.; */
  Global Const $CURLOPT_PROXYTYPE= $CURLOPTTYPE_LONG +101

  ;/* Set the Accept-Encoding string. Use this to tell a server you would like
  ;   the response to be compressed.; */
  Global Const $CURLOPT_ENCODING= $CURLOPTTYPE_OBJECTPOINT +102

  ;/* Set pointer to private data; */
  Global Const $CURLOPT_PRIVATE= $CURLOPTTYPE_OBJECTPOINT +103

  ;/* Set aliases for HTTP 200 in the HTTP Response header; */
  Global Const $CURLOPT_HTTP200ALIASES= $CURLOPTTYPE_OBJECTPOINT +104

  ;/* Continue to send authentication (user+password) when following locations,
  ;   even when hostname changed. This can potentially send off the name
  ;   and password to whatever host the server decides.; */
  Global Const $CURLOPT_UNRESTRICTED_AUTH= $CURLOPTTYPE_LONG +105

  ;/* Specifically switch on or off the FTP engine's use of the EPRT command ( it
  ;   also disables the LPRT attempt). By default, those ones will always be
  ;   attempted before the good old traditional PORT command.; */
  Global Const $CURLOPT_FTP_USE_EPRT= $CURLOPTTYPE_LONG +106

  ;/* Set this to a bitmask value to enable the particular authentications
  ;   methods you like. Use this in combination with CURLOPT_USERPWD.
  ;   Note that setting multiple bits may cause extra network round-trips.; */
  Global Const $CURLOPT_HTTPAUTH= $CURLOPTTYPE_LONG +107

  ;/* Set the ssl context callback function, currently only for OpenSSL ssl_ctx
  ;   in second argument. The function must be matching the
  ;   curl_ssl_ctx_callback proto.; */
  Global Const $CURLOPT_SSL_CTX_FUNCTION= $CURLOPTTYPE_FUNCTIONPOINT +108

  ;/* Set the userdata for the ssl context callback function's third
  ;   argument; */
  Global Const $CURLOPT_SSL_CTX_DATA= $CURLOPTTYPE_OBJECTPOINT +109

  ;/* FTP Option that causes missing dirs to be created on the remote server.
  ;   In 7.19.4 we introduced the convenience enums for this option using the
  ;   CURLFTP_CREATE_DIR prefix.
 ; */
  Global Const $CURLOPT_FTP_CREATE_MISSING_DIRS= $CURLOPTTYPE_LONG +110

  ;/* Set this to a bitmask value to enable the particular authentications
  ;   methods you like. Use this in combination with CURLOPT_PROXYUSERPWD.
  ;   Note that setting multiple bits may cause extra network round-trips.; */
  Global Const $CURLOPT_PROXYAUTH= $CURLOPTTYPE_LONG +111

  ;/* FTP option that changes the timeout, in seconds, associated with
  ;   getting a response.  This is different from transfer timeout time and
  ;   essentially places a demand on the FTP server to acknowledge commands
  ;   in a timely manner.; */
  Global Const $CURLOPT_FTP_RESPONSE_TIMEOUT= $CURLOPTTYPE_LONG +112

  ;/* Set this option to one of the CURL_IPRESOLVE_* defines (see below) to
  ;   tell libcurl to resolve names to those IP versions only. This only has
  ;   affect on systems with support for more than one, i.e IPv4 _and_ IPv6.; */
  Global Const $CURLOPT_IPRESOLVE= $CURLOPTTYPE_LONG +113

  ;/* Set this option to limit the size of a file that will be downloaded from
  ;   an HTTP or FTP server.
  ;
  ;   Note there is also _LARGE version which adds large file support for
  ;   platforms which have larger off_t sizes.  See MAXFILESIZE_LARGE below.; */
  Global Const $CURLOPT_MAXFILESIZE= $CURLOPTTYPE_LONG +114

  ;/* See the comment for INFILESIZE above, but in short, specifies
  ; * the size of the file being uploaded.  -1 means unknown.
  ; */
  Global Const $CURLOPT_INFILESIZE_LARGE= $CURLOPTTYPE_OFF_T +115

  ;/* Sets the continuation offset.  There is also a LONG version of this;
  ; * look above for RESUME_FROM.
  ; */
  Global Const $CURLOPT_RESUME_FROM_LARGE= $CURLOPTTYPE_OFF_T +116

  ;/* Sets the maximum size of data that will be downloaded from
  ; * an HTTP or FTP server.  See MAXFILESIZE above for the LONG version.
  ; */
  Global Const $CURLOPT_MAXFILESIZE_LARGE= $CURLOPTTYPE_OFF_T +117

  ;/* Set this option to the file name of your .netrc file you want libcurl
  ;   to parse (using the CURLOPT_NETRC option). If not set, libcurl will do
  ;   a poor attempt to find the user's home directory and check for a .netrc
  ;   file in there.; */
  Global Const $CURLOPT_NETRC_FILE= $CURLOPTTYPE_OBJECTPOINT +118

  ;/* Enable SSL/TLS for FTP, pick one of:
  ;   CURLFTPSSL_TRY     - try using SSL, proceed anyway otherwise
  ;   CURLFTPSSL_CONTROL - SSL for the control connection or fail
  ;   CURLFTPSSL_ALL     - SSL for all communication or fail
 ; */
  Global Const $CURLOPT_USE_SSL= $CURLOPTTYPE_LONG +119

  ;/* The _LARGE version of the standard POSTFIELDSIZE option; */
  Global Const $CURLOPT_POSTFIELDSIZE_LARGE= $CURLOPTTYPE_OFF_T +120

  ;/* Enable/disable the TCP Nagle algorithm; */
  Global Const $CURLOPT_TCP_NODELAY= $CURLOPTTYPE_LONG +121

  ;/* 122 OBSOLETE, used in 7.12.3. Gone in 7.13.0; */
  ;/* 123 OBSOLETE. Gone in 7.16.0; */
  ;/* 124 OBSOLETE, used in 7.12.3. Gone in 7.13.0; */
  ;/* 125 OBSOLETE, used in 7.12.3. Gone in 7.13.0; */
  ;/* 126 OBSOLETE, used in 7.12.3. Gone in 7.13.0; */
  ;/* 127 OBSOLETE. Gone in 7.16.0; */
  ;/* 128 OBSOLETE. Gone in 7.16.0; */

  ;/* When FTP over SSL/TLS is selected (with CURLOPT_USE_SSL this option
  ;   can be used to change libcurl's default action which is to first try
  ;   "AUTH SSL" and then "AUTH TLS" in this order, and proceed when a OK
  ;   response has been received.
  ;
  ;   Available parameters are:
  ;   CURLFTPAUTH_DEFAULT - let libcurl decide
  ;   CURLFTPAUTH_SSL     - try "AUTH SSL" first, then TLS
  ;   CURLFTPAUTH_TLS     - try "AUTH TLS" first, then SSL
 ; */
  Global Const $CURLOPT_FTPSSLAUTH= $CURLOPTTYPE_LONG +129

  Global Const $CURLOPT_IOCTLFUNCTION= $CURLOPTTYPE_FUNCTIONPOINT +130
  Global Const $CURLOPT_IOCTLDATA= $CURLOPTTYPE_OBJECTPOINT +131

  ;/* 132 OBSOLETE. Gone in 7.16.0; */
  ;/* 133 OBSOLETE. Gone in 7.16.0; */

  ;/* zero terminated string for pass on to the FTP server when asked for
  ;   "account" info; */
  Global Const $CURLOPT_FTP_ACCOUNT= $CURLOPTTYPE_OBJECTPOINT +134

  ;/* feed cookies into cookie engine; */
  Global Const $CURLOPT_COOKIELIST= $CURLOPTTYPE_OBJECTPOINT +135

  ;/* ignore Content-Length; */
  Global Const $CURLOPT_IGNORE_CONTENT_LENGTH= $CURLOPTTYPE_LONG +136

  ;/* Set to non-zero to skip the IP address received in a 227 PASV FTP server
  ;   response. Typically used for FTP-SSL purposes but is not restricted to
  ;   that. libcurl will then instead use the same IP address it used for the
  ;   control connection.; */
  Global Const $CURLOPT_FTP_SKIP_PASV_IP= $CURLOPTTYPE_LONG +137

  ;/* Select "file method" to use when doing FTP, see the curl_ftpmethod
  ;   above.; */
  Global Const $CURLOPT_FTP_FILEMETHOD= $CURLOPTTYPE_LONG +138

  ;/* Local port number to bind the socket to; */
  Global Const $CURLOPT_LOCALPORT= $CURLOPTTYPE_LONG +139

  ;/* Number of ports to try, including the first one set with LOCALPORT.
  ;   Thus, setting it to 1 will make no additional attempts but the first.
  ; */
  Global Const $CURLOPT_LOCALPORTRANGE= $CURLOPTTYPE_LONG +140

  ;/* no transfer, set up connection and let application use the socket by
  ;   extracting it with CURLINFO_LASTSOCKET; */
  Global Const $CURLOPT_CONNECT_ONLY= $CURLOPTTYPE_LONG +141

  ;/* Function that will be called to convert from the
  ;   network encoding (instead of using the iconv calls in libcurl); */
  Global Const $CURLOPT_CONV_FROM_NETWORK_FUNCTION= $CURLOPTTYPE_FUNCTIONPOINT +142

  ;/* Function that will be called to convert to the
  ;   network encoding (instead of using the iconv calls in libcurl); */
  Global Const $CURLOPT_CONV_TO_NETWORK_FUNCTION= $CURLOPTTYPE_FUNCTIONPOINT +143

  ;/* Function that will be called to convert from UTF8
  ;   (instead of using the iconv calls in libcurl)
  ;   Note that this is used only for SSL certificate processing; */
  Global Const $CURLOPT_CONV_FROM_UTF8_FUNCTION= $CURLOPTTYPE_FUNCTIONPOINT +144

  ;/* if the connection proceeds too quickly then need to slow it down; */
  ;/* limit-rate: maximum number of bytes per second to send or receive; */
  Global Const $CURLOPT_MAX_SEND_SPEED_LARGE= $CURLOPTTYPE_OFF_T +145
  Global Const $CURLOPT_MAX_RECV_SPEED_LARGE= $CURLOPTTYPE_OFF_T +146

  ;/* Pointer to command string to send if USER/PASS fails.; */
  Global Const $CURLOPT_FTP_ALTERNATIVE_TO_USER= $CURLOPTTYPE_OBJECTPOINT +147

  ;/* callback function for setting socket options; */
  Global Const $CURLOPT_SOCKOPTFUNCTION= $CURLOPTTYPE_FUNCTIONPOINT +148
  Global Const $CURLOPT_SOCKOPTDATA= $CURLOPTTYPE_OBJECTPOINT +149

  ;/* set to 0 to disable session ID re-use for this transfer, default is
  ;   enabled (== 1); */
  Global Const $CURLOPT_SSL_SESSIONID_CACHE= $CURLOPTTYPE_LONG +150

  ;/* allowed SSH authentication methods; */
  Global Const $CURLOPT_SSH_AUTH_TYPES= $CURLOPTTYPE_LONG +151

  ;/* Used by scp/sftp to do public/private key authentication; */
  Global Const $CURLOPT_SSH_PUBLIC_KEYFILE= $CURLOPTTYPE_OBJECTPOINT +152
  Global Const $CURLOPT_SSH_PRIVATE_KEYFILE= $CURLOPTTYPE_OBJECTPOINT +153

  ;/* Send CCC (Clear Command Channel) after authentication; */
  Global Const $CURLOPT_FTP_SSL_CCC= $CURLOPTTYPE_LONG +154

  ;/* Same as TIMEOUT and CONNECTTIMEOUT, but with ms resolution; */
  Global Const $CURLOPT_TIMEOUT_MS= $CURLOPTTYPE_LONG +155
  Global Const $CURLOPT_CONNECTTIMEOUT_MS= $CURLOPTTYPE_LONG +156

  ;/* set to zero to disable the libcurl's decoding and thus pass the raw body
  ;   data to the application even when it is encoded/compressed; */
  Global Const $CURLOPT_HTTP_TRANSFER_DECODING= $CURLOPTTYPE_LONG +157
  Global Const $CURLOPT_HTTP_CONTENT_DECODING= $CURLOPTTYPE_LONG +158

  ;/* Permission used when creating new files and directories on the remote
  ;   server for protocols that support it, SFTP/SCP/FILE; */
  Global Const $CURLOPT_NEW_FILE_PERMS= $CURLOPTTYPE_LONG +159
  Global Const $CURLOPT_NEW_DIRECTORY_PERMS= $CURLOPTTYPE_LONG +160

  ;/* Set the behaviour of POST when redirecting. Values must be set to one
  ;   of CURL_REDIR* defines below. This used to be called CURLOPT_POST301; */
  Global Const $CURLOPT_POSTREDIR= $CURLOPTTYPE_LONG +161

  ;/* used by scp/sftp to verify the host's public key; */
  Global Const $CURLOPT_SSH_HOST_PUBLIC_KEY_MD5= $CURLOPTTYPE_OBJECTPOINT +162

  ;/* Callback function for opening socket (instead of socket(2)). Optionally,
  ;   callback is able change the address or refuse to connect returning
  ;   CURL_SOCKET_BAD.  The callback should have type
  ;   curl_opensocket_callback; */
  Global Const $CURLOPT_OPENSOCKETFUNCTION= $CURLOPTTYPE_FUNCTIONPOINT +163
  Global Const $CURLOPT_OPENSOCKETDATA= $CURLOPTTYPE_OBJECTPOINT +164

  ;/* POST volatile input fields.; */
  Global Const $CURLOPT_COPYPOSTFIELDS= $CURLOPTTYPE_OBJECTPOINT +165

  ;/* set transfer mode (;type=<a|i>) when doing FTP via an HTTP proxy; */
  Global Const $CURLOPT_PROXY_TRANSFER_MODE= $CURLOPTTYPE_LONG +166

  ;/* Callback function for seeking in the input stream; */
  Global Const $CURLOPT_SEEKFUNCTION= $CURLOPTTYPE_FUNCTIONPOINT +167
  Global Const $CURLOPT_SEEKDATA= $CURLOPTTYPE_OBJECTPOINT +168

  ;/* CRL file; */
  Global Const $CURLOPT_CRLFILE= $CURLOPTTYPE_OBJECTPOINT +169

  ;/* Issuer certificate; */
  Global Const $CURLOPT_ISSUERCERT= $CURLOPTTYPE_OBJECTPOINT +170

  ;/* (IPv6) Address scope; */
  Global Const $CURLOPT_ADDRESS_SCOPE= $CURLOPTTYPE_LONG +171

  ;/* Collect certificate chain info and allow it to get retrievable with
  ;   CURLINFO_CERTINFO after the transfer is complete. (Unfortunately) only
  ;   working with OpenSSL-powered builds.; */
  Global Const $CURLOPT_CERTINFO= $CURLOPTTYPE_LONG +172

  ;/* "name" and "pwd" to use when fetching.; */
  Global Const $CURLOPT_USERNAME= $CURLOPTTYPE_OBJECTPOINT +173
  Global Const $CURLOPT_PASSWORD= $CURLOPTTYPE_OBJECTPOINT +174

    ;/* "name" and "pwd" to use with Proxy when fetching.; */
  Global Const $CURLOPT_PROXYUSERNAME= $CURLOPTTYPE_OBJECTPOINT +175
  Global Const $CURLOPT_PROXYPASSWORD= $CURLOPTTYPE_OBJECTPOINT +176

  ;/* Comma separated list of hostnames defining no-proxy zones. These should
  ;   match both hostnames directly, and hostnames within a domain. For
  ;   example, local.com will match local.com and www.local.com, but NOT
  ;   notlocal.com or www.notlocal.com. For compatibility with other
  ;   implementations of this, .local.com will be considered to be the same as
  ;   local.com. A single; * is the only valid wildcard, and effectively
  ;   disables the use of proxy.; */
  Global Const $CURLOPT_NOPROXY= $CURLOPTTYPE_OBJECTPOINT +177

  ;/* block size for TFTP transfers; */
  Global Const $CURLOPT_TFTP_BLKSIZE= $CURLOPTTYPE_LONG +178

  ;/* Socks Service; */
  Global Const $CURLOPT_SOCKS5_GSSAPI_SERVICE= $CURLOPTTYPE_OBJECTPOINT +179

  ;/* Socks Service; */
  Global Const $CURLOPT_SOCKS5_GSSAPI_NEC= $CURLOPTTYPE_LONG +180

  ;/* set the bitmask for the protocols that are allowed to be used for the
  ;   transfer, which thus helps the app which takes URLs from users or other
  ;   external inputs and want to restrict what protocol(s) to deal
  ;   with. Defaults to CURLPROTO_ALL.; */
  Global Const $CURLOPT_PROTOCOLS= $CURLOPTTYPE_LONG +181

  ;/* set the bitmask for the protocols that libcurl is allowed to follow to,
  ;   as a subset of the CURLOPT_PROTOCOLS ones. That means the protocol needs
  ;   to be set in both bitmasks to be allowed to get redirected to. Defaults
  ;   to all protocols except FILE and SCP.; */
  Global Const $CURLOPT_REDIR_PROTOCOLS= $CURLOPTTYPE_LONG +182

  ;/* set the SSH knownhost file name to use; */
  Global Const $CURLOPT_SSH_KNOWNHOSTS= $CURLOPTTYPE_OBJECTPOINT +183

  ;/* set the SSH host key callback, must point to a curl_sshkeycallback
  ;   function; */
  Global Const $CURLOPT_SSH_KEYFUNCTION= $CURLOPTTYPE_FUNCTIONPOINT +184

  ;/* set the SSH host key callback custom pointer; */
  Global Const $CURLOPT_SSH_KEYDATA= $CURLOPTTYPE_OBJECTPOINT +185

;  CURLOPT_LASTENTRY ;/* the last unused; */
;} CURLoption;




  ;/* Below here follows defines for the CURLOPT_IPRESOLVE option. If a host
  ;   name resolves addresses using more than one IP protocol version, this
  ;   option might be handy to force libcurl to use a specific IP version.; */
Global Const $CURL_IPRESOLVE_WHATEVER = 0 ;/* default, resolves addresses to all IP
                                     ;versions that your system allows; */
Global Const $CURL_IPRESOLVE_V4       = 1 ;/* resolve to ipv4 addresses; */
Global Const $CURL_IPRESOLVE_V6       = 2 ;/* resolve to ipv6 addresses; */

  ;/* three convenient "aliases" that follow the name scheme better; */
Global Const $CURLOPT_WRITEDATA = $CURLOPT_FILE
Global Const $CURLOPT_READDATA  = $CURLOPT_INFILE
Global Const $CURLOPT_HEADERDATA = $CURLOPT_WRITEHEADER

  ;/* These enums are for use with the CURLOPT_HTTP_VERSION option.; */
Global enum _ ;{
  $CURL_HTTP_VERSION_NONE, _  ;/* setting this means we don't care, and that we'd like the library to choose the best possible for us!; */
  $CURL_HTTP_VERSION_1_0, _   ;/* please use HTTP 1.0 in the request; */
  $CURL_HTTP_VERSION_1_1, _   ;/* please use HTTP 1.1 in the request; */
  $CURL_HTTP_VERSION_LAST ;/*; *ILLEGAL* http version; */
;};

  ;/* These enums are for use with the CURLOPT_NETRC option.; */
Global enum _ ;CURL_NETRC_OPTION {
  $CURL_NETRC_IGNORED, _     ;/* The .netrc will never be read. This is the default.; */
  $CURL_NETRC_OPTIONAL, _    ;/* A user:password in the URL will be preferred to one in the .netrc.; */
  $CURL_NETRC_REQUIRED, _    ;/* A user:password in the URL will be ignored. Unless one is set programmatically, the .netrc will be queried.; */
  $CURL_NETRC_LAST
;};

Global enum _ ;{
  $CURL_SSLVERSION_DEFAULT, _
  $CURL_SSLVERSION_TLSv1, _
  $CURL_SSLVERSION_SSLv2, _
  $CURL_SSLVERSION_SSLv3, _
  $CURL_SSLVERSION_LAST ;/* never use, keep last; */
;};

;/* symbols to use with CURLOPT_POSTREDIR.
;   CURL_REDIR_POST_301 and CURL_REDIR_POST_302 can be bitwise ORed so that
;   CURL_REDIR_POST_301 | CURL_REDIR_POST_302 == CURL_REDIR_POST_ALL; */

Global Const $CURL_REDIR_GET_ALL  = 0
Global Const $CURL_REDIR_POST_301 = 1
Global Const $CURL_REDIR_POST_302 = 2
Global Const $CURL_REDIR_POST_ALL = BitOR($CURL_REDIR_POST_301,$CURL_REDIR_POST_302)

Global enum _ ;{
  $CURL_TIMECOND_NONE, _
  $CURL_TIMECOND_IFMODSINCE, _
  $CURL_TIMECOND_IFUNMODSINCE, _
  $CURL_TIMECOND_LASTMOD, _
  $CURL_TIMECOND_LAST
;} curl_TimeCond;


;/* curl_strequal() and curl_strnequal() are subject for removal in a future
;   libcurl, see lib/README.curlx for details; */
;CURL_EXTERN int (curl_strequal)(const char *s1, const char *s2);
;CURL_EXTERN int (curl_strnequal)(const char *s1, const char *s2, size_t n);

;/* name is uppercase CURLFORM_<name>; */
;#ifdef CFINIT
;#undef CFINIT
;#endif
#cs
#ifdef CURL_ISOCPP
Global Const $CFINIT(name) CURLFORM_ ## name
#else
;/* The macro "##" is ISO C, we assume pre-ISO C doesn't support it.; */
Global Const $CFINIT(name) CURLFORM_/**/name
#endif
#ce

Global enum _ ;{
  $CURLFORM_NOTHING, _        ;/********* the first one is unused; ************/
  $CURLFORM_COPYNAME, _
  $CURLFORM_PTRNAME, _
  $CURLFORM_NAMELENGTH, _
  $CURLFORM_COPYCONTENTS, _
  $CURLFORM_PTRCONTENTS, _
  $CURLFORM_CONTENTSLENGTH, _
  $CURLFORM_FILECONTENT, _
  $CURLFORM_ARRAY, _
  $CURLFORM_OBSOLETE, _
  $CURLFORM_FILE, _
  $CURLFORM_BUFFER, _
  $CURLFORM_BUFFERPTR, _
  $CURLFORM_BUFFERLENGTH, _
  $CURLFORM_CONTENTTYPE, _
  $CURLFORM_CONTENTHEADER, _
  $CURLFORM_FILENAME, _
  $CURLFORM_END, _
  $CURLFORM_OBSOLETE2, _
  $CURLFORM_STREAM, _
  $CURLFORM_LASTENTRY ;/* the last unused; */
;} CURLformoption;

;#undef CFINIT ;/* done; */

;/* structure to be used as parameter for CURLFORM_ARRAY; */
Global Const $tagCURL_FORMS = _ ;{
  "dword option;" & _
  "ptr value;" ; [char*]
;};

;/* use this for multipart formpost building; */
;/* Returns code for curl_formadd()
; *
; * Returns:
; * CURL_FORMADD_OK             on success
; * CURL_FORMADD_MEMORY         if the FormInfo allocation fails
; * CURL_FORMADD_OPTION_TWICE   if one option is given twice for one Form
; * CURL_FORMADD_NULL           if a null pointer was given for a char
; * CURL_FORMADD_MEMORY         if the allocation of a FormInfo struct failed
; * CURL_FORMADD_UNKNOWN_OPTION if an unknown option was used
; * CURL_FORMADD_INCOMPLETE     if the some FormInfo is not complete (or error)
; * CURL_FORMADD_MEMORY         if a curl_httppost struct cannot be allocated
; * CURL_FORMADD_MEMORY         if some allocation for string copying failed.
; * CURL_FORMADD_ILLEGAL_ARRAY  if an illegal option is used in an array
; *
; ***************************************************************************/
Global enum _ ;{
  $CURL_FORMADD_OK, _ ;/* first, no error; */
  $CURL_FORMADD_MEMORY, _
  $CURL_FORMADD_OPTION_TWICE, _
  $CURL_FORMADD_NULL, _
  $CURL_FORMADD_UNKNOWN_OPTION, _
  $CURL_FORMADD_INCOMPLETE, _
  $CURL_FORMADD_ILLEGAL_ARRAY, _
  $CURL_FORMADD_DISABLED, _ ;/* libcurl was built with this disabled; */
  $CURL_FORMADD_LAST ;/* last; */
;} CURLFORMcode;

;/*
; * NAME curl_formadd()
; *
; * DESCRIPTION
; *
; * Pretty advanced function for building multi-part formposts. Each invoke
; * adds one part that together construct a full post. Then use
; * CURLOPT_HTTPPOST to send it off to libcurl.
; */
;CURL_EXTERN CURLFORMcode curl_formadd(struct curl_httppost **httppost,
;                                      struct curl_httppost **last_post,
;                                      ...);

Func _CURL_formadd(ByRef $pHttpPost, ByRef $pLastPost, $option1, $value1, $option2, $value2=0, $option3=0, $value3=0, $option4=0, $value4=0, _
						$option5=0, $value5=0, $option6=0, $value6=0, $option7=0, $value7=0, $option8=0, $value8=0, $option9=0, $value9=0, _
						$option10=0, $value10=0, $option11=0, $value11=0, $option12=0, $value12=0, $option13=0, $value13=0, $option14=0, $value14=0, _
						$option15=0, $value15=0, $option16=0, $value16=0, $option17=0, $value17=0, $option18=0, $value18=0, $option19=0, $value19=0, _
						$option20=0, $value20=0)
	If Mod(@NumParams,2)<>1 Then Return SetError(1,0,$CURL_FORMADD_LAST )
	Local $aType[2] = ['int', 'str']
	Switch @NumParams
		Case 5
			Local $aResult = DllCall($ghLIBCURLdll, "dword:cdecl", "curl_formadd", "ptr*", $pHttpPost, "ptr*", $pLastPost, "dword", $option1, $aType[IsString($value1)], $value1, _
								"dword", $option2)
			If @error Then Return SetError(2,0,$CURL_FORMADD_LAST )
		Case 7
			Local $aResult = DllCall($ghLIBCURLdll, "dword:cdecl", "curl_formadd", "ptr*", $pHttpPost, "ptr*", $pLastPost, "dword", $option1, $aType[IsString($value1)], $value1, _
								"dword", $option2, $aType[IsString($value2)], $value1, _
								"dword", $option3)
			If @error Then Return SetError(2,0,$CURL_FORMADD_LAST )
		Case 9
			Local $aResult = DllCall($ghLIBCURLdll, "dword:cdecl", "curl_formadd", "ptr*", $pHttpPost, "ptr*", $pLastPost, "dword", $option1, $aType[IsString($value1)], $value1, _
								"dword", $option2, $aType[IsString($value2)], $value2, _
								"dword", $option3, $aType[IsString($value3)], $value3, _
								"dword", $option4)
			If @error Then Return SetError(2,0,$CURL_FORMADD_LAST )
		Case 11
			Local $aResult = DllCall($ghLIBCURLdll, "dword:cdecl", "curl_formadd", "ptr*", $pHttpPost, "ptr*", $pLastPost, "dword", $option1, $aType[IsString($value1)], $value1, _
								"dword", $option2, $aType[IsString($value2)], $value2, _
								"dword", $option3, $aType[IsString($value3)], $value3, _
								"dword", $option4, $aType[IsString($value4)], $value4, _
								"dword", $option5)
			If @error Then Return SetError(2,0,$CURL_FORMADD_LAST )
		Case Else
			Local $sFunc = 'DllCall($ghLIBCURLdll, "dword:cdecl", "curl_formadd", "ptr*", $pHttpPost, "ptr*", $pLastPost'
			For $i = 1 To (@NumParams-3)/2
				$sFunc &= ', "int", $option'& $i & ', "' & $aType[IsString(Eval("value"&$i))] & '", $value' & $i
			Next
			$sFunc &= ', "dword", $option' & ($i+1) & ')'
			Local $aResult = Execute($sFunc)
			If @error Then Return SetError(2,0,$CURL_FORMADD_LAST )
	EndSwitch
	$pHttpPost = $aResult[1]
	$pLastPost = $aResult[2]
	Return $aResult[0]
EndFunc

;/*
; * callback function for curl_formget()
; * The void *arg pointer will be the one passed as second argument to
; *   curl_formget().
; * The character buffer passed to it must not be freed.
; * Should return the buffer length passed to it as the argument "len" on
; *   success.
; */
;~ typedef size_t (*curl_formget_callback)(void *arg, const char *buf, size_t len);
Func _curl_formget_callback_Register($Function)
	Return DllCallbackRegister($Function, "uint:cdecl", "ptr;ptr;uint")
EndFunc
Func _curl_formget_callback($arg, $buf, $len)
	; exmample callback function
	ConsoleWrite( "------------------------------------" & @CRLF & "> _curl_formget_callback" & @CRLF & _
		"arg: " & $len		& @CRLF & _
		"buf: " & $buf		& @CRLF & _
		"len: " & $len		& @CRLF & _
		'')
EndFunc

;/*
; * NAME curl_formget()
; *
; * DESCRIPTION
; *
; * Serialize a curl_httppost struct built with curl_formadd().
; * Accepts a void pointer as second argument which will be passed to
; * the curl_formget_callback function.
; * Returns 0 on success.
; */
;~ CURL_EXTERN int curl_formget(struct curl_httppost *form, void *arg,
;~                              curl_formget_callback append);
Func _curl_formget($form, $arg, $append)
	Local $aResult = DllCall($ghLIBCURLdll, "int:cdecl", "curl_formget", "ptr", $form, "ptr", $arg, "ptr", $append)
	If @error Then Return SetError(1,0,0)
	Return $aResult[0]
EndFunc
;/*
; * NAME curl_formfree()
; *
; * DESCRIPTION
; *
; * Free a multipart formpost previously built with curl_formadd().
; */
;~ CURL_EXTERN void curl_formfree(struct curl_httppost *form);
Func _curl_formfree($form)
	Local $aResult = DllCall($ghLIBCURLdll, "none:cdecl", "curl_formfree", "ptr", $form)
	If @error Then Return SetError(1)
EndFunc

;/*
; * NAME curl_getenv()
; *
; * DESCRIPTION
; *
; * Returns a malloc()'ed string that MUST be curl_free()ed after usage is
; * complete. DEPRECATED - see lib/README.curlx
; */
;~ CURL_EXTERN char *curl_getenv(const char *variable);

;/*
; * NAME curl_version()
; *
; * DESCRIPTION
; *
; * Returns a static ascii string of the libcurl version.
; */
;~ CURL_EXTERN char *curl_version(void);
Func _curl_version()
	Local $aResult = DllCall($ghLIBCURLdll, "str:cdecl", "curl_version")
	If @error Then Return SetError(1,0,'')
	Return $aResult[0]
EndFunc

;/*
; * NAME curl_easy_escape()
; *
; * DESCRIPTION
; *
; * Escapes URL strings (converts all letters consider illegal in URLs to their
; * %XX versions). This function returns a new allocated string or NULL if an
; * error occurred.
; */
;~ CURL_EXTERN char *curl_easy_escape(CURL *handle,
;~                                    const char *string,
;~                                    int length);
Func _curl_easy_escape($handle, $string, $length)
	Local $aResult = DllCall($ghLIBCURLdll, "ptr:cdecl", "curl_easy_escape", 'ptr', $handle, 'str', $string, 'int', $length)
	If @error Or $aResult[0] = 0 Then Return SetError(1,0,'')
	$aResult[1] = __CURL_PtrStringRead($aResult[0])
	_curl_free($aResult[0])
	Return $aResult[1]
EndFunc

;/* the previous version:; */
;~ CURL_EXTERN char *curl_escape(const char *string,
;~                               int length);


;/*
; * NAME curl_easy_unescape()
; *
; * DESCRIPTION
; *
; * Unescapes URL encoding in strings (converts all %XX codes to their 8bit
; * versions). This function returns a new allocated string or NULL if an error
; * occurred.
; * Conversion Note: On non-ASCII platforms the ASCII %XX codes are
; * converted into the host encoding.
; */
;~ CURL_EXTERN char *curl_easy_unescape(CURL *handle,
;~                                      const char *string,
;~                                      int length,
;~                                      int *outlength);
Func _curl_easy_unescape($handle, $string, $length, ByRef $outlength)
	Local $aResult = DllCall($ghLIBCURLdll, "ptr:cdecl", "curl_easy_unescape", 'ptr', $handle, 'str', $string, 'int', $length, 'int*', $outlength)
	If @error Or $aResult[0] = 0 Then Return SetError(1,0,'')
	$outlength = $aResult[4]
	$aResult[1] = __CURL_PtrStringRead($aResult[0], False, $outlength)
	_curl_free($aResult[0])
	Return $aResult[1]
EndFunc

;/* the previous version; */
;~ CURL_EXTERN char *curl_unescape(const char *string,
;~                                 int length);

;/*
; * NAME curl_free()
; *
; * DESCRIPTION
; *
; * Provided for de-allocation in the same translation unit that did the
; * allocation. Added in libcurl 7.10
; */
;~ CURL_EXTERN void curl_free(void *p);
Func _curl_free($p)
	Local $aResult = DllCall($ghLIBCURLdll, "none:cdecl", "curl_free", 'ptr', $p)
	If @error Then Return SetError(1)
EndFunc


Global Const $CURL_GLOBAL_SSL = BitShift(1, 0)
Global Const $CURL_GLOBAL_WIN32 = BitShift(1, -1)
Global Const $CURL_GLOBAL_ALL = BitOR($CURL_GLOBAL_SSL, $CURL_GLOBAL_WIN32)
Global Const $CURL_GLOBAL_NOTHING = 0
Global Const $CURL_GLOBAL_DEFAULT = $CURL_GLOBAL_ALL

;/*
; * NAME curl_global_init()
; *
; * DESCRIPTION
; *
; * curl_global_init() should be invoked exactly once for each application that
; * uses libcurl and before any call of other libcurl functions.
; *
; * This function is not thread-safe!
; */
;~ CURL_EXTERN CURLcode curl_global_init(long flags);
Func _curl_global_init($flags=$CURL_GLOBAL_ALL)
	Local $aResult = DllCall($ghLIBCURLdll, "int:cdecl", "curl_global_init", 'long', $flags)
	If @error Then Return SetError(1, 0, $CURL_LAST)
	Return $aResult[0]
EndFunc

;/*
; * NAME curl_global_init_mem()
; *
; * DESCRIPTION
; *
; * curl_global_init() or curl_global_init_mem() should be invoked exactly once
; * for each application that uses libcurl.  This function can be used to
; * initialize libcurl and set user defined memory management callback
; * functions.  Users can implement memory management routines to check for
; * memory leaks, check for mis-use of the curl library etc.  User registered
; * callback routines with be invoked by this library instead of the system
; * memory management routines like malloc, free etc.
; */
;~ CURL_EXTERN CURLcode curl_global_init_mem(long flags,
;~                                           curl_malloc_callback m,
;~                                           curl_free_callback f,
;~                                           curl_realloc_callback r,
;~                                           curl_strdup_callback s,
;~                                           curl_calloc_callback c);


;/*
; * NAME curl_global_cleanup()
; *
; * DESCRIPTION
; *
; * curl_global_cleanup() should be invoked exactly once for each application
; * that uses libcurl
; */
;~ CURL_EXTERN void curl_global_cleanup(void);
Func _curl_global_cleanup()
	Local $aResult = DllCall($ghLIBCURLdll, "none:cdecl", "curl_global_cleanup")
	If @error Then Return SetError(1)
EndFunc

;/* linked-list structure for the CURLOPT_QUOTE option (and other); */
Global Const $tagCURL_SLIST = _ ;{
  "ptr data;" & _ ; [char *]
  "ptr next;" ;[struct curl_slist *]
;}

;/*
; * NAME curl_slist_append()
; *
; * DESCRIPTION
; *
; * Appends a string to a linked list. If no list exists, it will be created
; * first. Returns the new list, after appending.
; */
;~ CURL_EXTERN struct curl_slist *curl_slist_append(struct curl_slist; *,
;~                                                  const char *);
Func _curl_slist_append($slist, $append)
	Local $aResult = DllCall($ghLIBCURLdll, "ptr:cdecl", "curl_slist_append", 'ptr', $slist, 'str', $append)
	If @error Then Return SetError(1, 0, 0)
	Return $aResult[0]
EndFunc

;/*
; * NAME curl_slist_free_all()
; *
; * DESCRIPTION
; *
; * free a previously built curl_slist.
; */
;~ CURL_EXTERN void curl_slist_free_all(struct curl_slist *);
Func _curl_slist_free_all($slist)
	Local $aResult = DllCall($ghLIBCURLdll, "none:cdecl", "curl_slist_free_all", "ptr", $slist)
	If @error Then Return SetError(1)
EndFunc

;/*
; * NAME curl_getdate()
; *
; * DESCRIPTION
; *
; * Returns the time, in seconds since 1 Jan 1970 of the time string given in
; * the first argument. The time argument in the second parameter is unused
; * and should be set to NULL.
; */
;~ CURL_EXTERN time_t curl_getdate(const char *p, const time_t *unused);
Func _curl_getdate($time, $unused=0)
	Local $aResult = DllCall($ghLIBCURLdll, "uint:cdecl", "curl_getdate", 'str', $time, 'ptr', 0)
	If @error Then Return SetError(1, 0, 0)
	Return $aResult[0]
EndFunc

;/* info about the certificate chain, only for OpenSSL builds. Asked
;   for with CURLOPT_CERTINFO / CURLINFO_CERTINFO; */
Global Const $tagCURL_CERTINFO = _ ;{
  "int num_of_certs;" & _ 	;/* number of certificates with information; */
  "ptr certinfo;" 			; [struct curl_slist **]
							;/* for each index in this array, there's a
							;   linked list with textual information in the
							;   format "name: value"; */
;};

Global Const $CURLINFO_STRING   = 0x100000
Global Const $CURLINFO_LONG     = 0x200000
Global Const $CURLINFO_DOUBLE   = 0x300000
Global Const $CURLINFO_SLIST    = 0x400000
Global Const $CURLINFO_MASK     = 0x0fffff
Global Const $CURLINFO_TYPEMASK = 0xf00000

;typedef enum {
  Global Const $CURLINFO_NONE=0 ;/* first, never use this; */
  Global Const $CURLINFO_EFFECTIVE_URL    = $CURLINFO_STRING + 1
  Global Const $CURLINFO_RESPONSE_CODE    = $CURLINFO_LONG   + 2
  Global Const $CURLINFO_TOTAL_TIME       = $CURLINFO_DOUBLE + 3
  Global Const $CURLINFO_NAMELOOKUP_TIME  = $CURLINFO_DOUBLE + 4
  Global Const $CURLINFO_CONNECT_TIME     = $CURLINFO_DOUBLE + 5
  Global Const $CURLINFO_PRETRANSFER_TIME = $CURLINFO_DOUBLE + 6
  Global Const $CURLINFO_SIZE_UPLOAD      = $CURLINFO_DOUBLE + 7
  Global Const $CURLINFO_SIZE_DOWNLOAD    = $CURLINFO_DOUBLE + 8
  Global Const $CURLINFO_SPEED_DOWNLOAD   = $CURLINFO_DOUBLE + 9
  Global Const $CURLINFO_SPEED_UPLOAD     = $CURLINFO_DOUBLE + 10
  Global Const $CURLINFO_HEADER_SIZE      = $CURLINFO_LONG   + 11
  Global Const $CURLINFO_REQUEST_SIZE     = $CURLINFO_LONG   + 12
  Global Const $CURLINFO_SSL_VERIFYRESULT = $CURLINFO_LONG   + 13
  Global Const $CURLINFO_FILETIME         = $CURLINFO_LONG   + 14
  Global Const $CURLINFO_CONTENT_LENGTH_DOWNLOAD   = $CURLINFO_DOUBLE + 15
  Global Const $CURLINFO_CONTENT_LENGTH_UPLOAD     = $CURLINFO_DOUBLE + 16
  Global Const $CURLINFO_STARTTRANSFER_TIME = $CURLINFO_DOUBLE + 17
  Global Const $CURLINFO_CONTENT_TYPE     = $CURLINFO_STRING + 18
  Global Const $CURLINFO_REDIRECT_TIME    = $CURLINFO_DOUBLE + 19
  Global Const $CURLINFO_REDIRECT_COUNT   = $CURLINFO_LONG   + 20
  Global Const $CURLINFO_PRIVATE          = $CURLINFO_STRING + 21
  Global Const $CURLINFO_HTTP_CONNECTCODE = $CURLINFO_LONG   + 22
  Global Const $CURLINFO_HTTPAUTH_AVAIL   = $CURLINFO_LONG   + 23
  Global Const $CURLINFO_PROXYAUTH_AVAIL  = $CURLINFO_LONG   + 24
  Global Const $CURLINFO_OS_ERRNO         = $CURLINFO_LONG   + 25
  Global Const $CURLINFO_NUM_CONNECTS     = $CURLINFO_LONG   + 26
  Global Const $CURLINFO_SSL_ENGINES      = $CURLINFO_SLIST  + 27
  Global Const $CURLINFO_COOKIELIST       = $CURLINFO_SLIST  + 28
  Global Const $CURLINFO_LASTSOCKET       = $CURLINFO_LONG   + 29
  Global Const $CURLINFO_FTP_ENTRY_PATH   = $CURLINFO_STRING + 30
  Global Const $CURLINFO_REDIRECT_URL     = $CURLINFO_STRING + 31
  Global Const $CURLINFO_PRIMARY_IP       = $CURLINFO_STRING + 32
  Global Const $CURLINFO_APPCONNECT_TIME  = $CURLINFO_DOUBLE + 33
  Global Const $CURLINFO_CERTINFO         = $CURLINFO_SLIST  + 34
  Global Const $CURLINFO_CONDITION_UNMET  = $CURLINFO_LONG   + 35
  ;/* Fill in new entries below here!; */

  Global Const $CURLINFO_LASTONE          = 35
;} CURLINFO;

;/* CURLINFO_RESPONSE_CODE is the new name for the option previously known as CURLINFO_HTTP_CODE; */
Global Const $CURLINFO_HTTP_CODE = $CURLINFO_RESPONSE_CODE

Global enum _ ;{
  $CURLCLOSEPOLICY_NONE, _ ;/* first, never use this; */
  $CURLCLOSEPOLICY_OLDEST, _
  $CURLCLOSEPOLICY_LEAST_RECENTLY_USED, _
  $CURLCLOSEPOLICY_LEAST_TRAFFIC, _
  $CURLCLOSEPOLICY_SLOWEST, _
  $CURLCLOSEPOLICY_CALLBACK, _
  $CURLCLOSEPOLICY_LAST ;/* last, never use this; */
;} curl_closepolicy;


;/*****************************************************************************
; * Setup defines, protos etc for the sharing stuff.
; */

;/* Different data locks for a single share; */
  ;/*  CURL_LOCK_DATA_SHARE is used internally to say that
  ; *  the locking is just made to change the internal state of the share
  ; *  itself.
  ; */
Global enum _ ;{
  $CURL_LOCK_DATA_NONE = 0, _
  $CURL_LOCK_DATA_SHARE, _
  $CURL_LOCK_DATA_COOKIE, _
  $CURL_LOCK_DATA_DNS, _
  $CURL_LOCK_DATA_SSL_SESSION, _
  $CURL_LOCK_DATA_CONNECT, _
  $CURL_LOCK_DATA_LAST
;} curl_lock_data;

;/* Different lock access types; */
Global enum _ ;{
  $CURL_LOCK_ACCESS_NONE = 0, _    ;/* unspecified action; */
  $CURL_LOCK_ACCESS_SHARED = 1, _  ;/* for read perhaps; */
  $CURL_LOCK_ACCESS_SINGLE = 2, _  ;/* for write perhaps; */
  $CURL_LOCK_ACCESS_LAST           ;/* never use; */
;} curl_lock_access;

;~ typedef void (*curl_lock_function)(CURL *handle,
;~                                    curl_lock_data data,
;~                                    curl_lock_access locktype,
;~                                    void *userptr);
;~ typedef void (*curl_unlock_function)(CURL *handle,
;~                                      curl_lock_data data,
;~                                      void *userptr);

;typedef void CURLSH;

Global enum _ ;{
  $CURLSHE_OK, _   ;/* all is fine; */
  $CURLSHE_BAD_OPTION, _  ;/* 1; */
  $CURLSHE_IN_USE, _      ;/* 2; */
  $CURLSHE_INVALID, _     ;/* 3; */
  $CURLSHE_NOMEM, _       ;/* out of memory; */
  $CURLSHE_LAST ;/* never use; */
;} CURLSHcode;

Global enum _ ;{
  $CURLSHOPT_NONE, _   ;/* don't use; */
  $CURLSHOPT_SHARE, _    ;/* specify a data type to share; */
  $CURLSHOPT_UNSHARE, _  ;/* specify which data type to stop sharing; */
  $CURLSHOPT_LOCKFUNC, _    ;/* pass in a 'curl_lock_function' pointer; */
  $CURLSHOPT_UNLOCKFUNC, _  ;/* pass in a 'curl_unlock_function' pointer; */
  $CURLSHOPT_USERDATA, _    ;/* pass in a user data pointer used in the lock/unlock callback functions; */
  $CURLSHOPT_LAST  ;/* never use; */
;} CURLSHoption;

;~ CURL_EXTERN CURLSH *curl_share_init(void);
Func _curl_share_init()
	Local $aResult = DllCall($ghLIBCURLdll, "ptr:cdecl", "curl_share_init")
	If @error Then Return SetError(1, 0, 0)
	Return $aResult[0]
EndFunc
;~ CURL_EXTERN CURLSHcode curl_share_setopt(CURLSH *, CURLSHoption option, ...);
Func _curl_share_setopt($curlsh, $option, $value)
	Local $aResult = DllCall($ghLIBCURLdll, "int:cdecl", "curl_share_setopt", 'ptr', $curlsh, 'int', $option, 'ptr', $value)
	If @error Then Return SetError(1, 0, $CURLSHE_LAST)
	Return $aResult[0]
EndFunc
;~ CURL_EXTERN CURLSHcode curl_share_cleanup(CURLSH *);
Func _curl_share_cleanup($curlsh)
	Local $aResult = DllCall($ghLIBCURLdll, "int:cdecl", "curl_share_cleanup", 'ptr', $curlsh)
	If @error Then Return SetError(1, 0, $CURLSHE_LAST)
	Return $aResult[0]
EndFunc

;/****************************************************************************
; * Structures for querying information about the curl library at runtime.
; */

Global enum _ ;{
  $CURLVERSION_FIRST, _
  $CURLVERSION_SECOND, _
  $CURLVERSION_THIRD, _
  $CURLVERSION_FOURTH, _
  $CURLVERSION_LAST ;/* never actually use this; */
;} CURLversion;

;/* The 'CURLVERSION_NOW' is the symbolic name meant to be used by
;   basically all programs ever that want to get version information. It is
;   meant to be a built-in version number for what kind of struct the caller
;   expects. If the struct ever changes, we redefine the NOW to another enum
;   from above.; */
Global Const $CURLVERSION_NOW = $CURLVERSION_FOURTH

Global Const $tagCURL_VERSION_INFO_DATA = _ ;{
  "int age;" & _           ;/* age of the returned struct; */
  "ptr version;" & _       ;/* LIBCURL_VERSION; */ [const char *]
  "uint version_num;" & _  ;/* LIBCURL_VERSION_NUM; */
  "ptr host;" & _          ;/* OS/host/cpu/machine when configured; */ [const char *]
  "int features;" & _              ;/* bitmask, see defines below; */
  "ptr ssl_version;" & _   ;/* human readable string; */ [const char *]
  "long ssl_version_num;" & _      ;/* not used anymore, always 0; */
  "ptr libz_version;" & _  ;/* human readable string; */ [const char *]
  "ptr protocols;" & _ ;/* protocols is terminated by an entry with a NULL protoname; */ _ [const char * const *]
  ''& _ ;/* The fields below this were added in CURLVERSION_SECOND; */
  "ptr ares;" & _ ;[const char *]
  "int ares_num;" & _
  '' & _ ;/* This field was added in CURLVERSION_THIRD; */
  "ptr libidn;" & _ ;[const char *]
  '' & _ ;/* These field were added in CURLVERSION_FOURTH; */
  '' & _ ;/* Same as '_libiconv_version' if built with HAVE_ICONV; */
  "int iconv_ver_num;" & _
  "const char *libssh_version;" ;/* human readable string; */
;} curl_version_info_data;

Global Const $CURL_VERSION_IPV6      = BitShift(1, -0)  ;/* IPv6-enabled; */
Global Const $CURL_VERSION_KERBEROS4 = BitShift(1, -1)  ;/* kerberos auth is supported; */
Global Const $CURL_VERSION_SSL       = BitShift(1, -2)  ;/* SSL options are present; */
Global Const $CURL_VERSION_LIBZ      = BitShift(1, -3)  ;/* libz features are present; */
Global Const $CURL_VERSION_NTLM      = BitShift(1, -4)  ;/* NTLM auth is supported; */
Global Const $CURL_VERSION_GSSNEGOTIATE = BitShift(1, -5) ;/* Negotiate auth support; */
Global Const $CURL_VERSION_DEBUG     = BitShift(1, -6)  ;/* built with debug capabilities; */
Global Const $CURL_VERSION_ASYNCHDNS = BitShift(1, -7)  ;/* asynchronous dns resolves; */
Global Const $CURL_VERSION_SPNEGO    = BitShift(1, -8)  ;/* SPNEGO auth; */
Global Const $CURL_VERSION_LARGEFILE = BitShift(1, -9)  ;/* supports files bigger than 2GB; */
Global Const $CURL_VERSION_IDN       = BitShift(1, -10) ;/* International Domain Names support; */
Global Const $CURL_VERSION_SSPI      = BitShift(1, -11) ;/* SSPI is supported; */
Global Const $CURL_VERSION_CONV      = BitShift(1, -12) ;/* character conversions supported; */
Global Const $CURL_VERSION_CURLDEBUG = BitShift(1, -13) ;/* debug memory tracking supported; */

;/*
; * NAME curl_version_info()
; *
; * DESCRIPTION
; *
; * This function returns a pointer to a static copy of the version info
; * struct. See above.
; */
;~ CURL_EXTERN curl_version_info_data *curl_version_info(CURLversion);

;/*
; * NAME curl_easy_strerror()
; *
; * DESCRIPTION
; *
; * The curl_easy_strerror function may be used to turn a CURLcode value
; * into the equivalent human readable error string.  This is useful
; * for printing meaningful error messages.
; */
;~ CURL_EXTERN const char *curl_easy_strerror(CURLcode);
Func _curl_easy_strerror($code)
	Local $aResult = DllCall($ghLIBCURLdll, "str:cdecl", "curl_easy_strerror", 'int', $code)
	If @error Then Return SetError(1, 0, '')
	Return $aResult[0]
EndFunc

;/*
; * NAME curl_share_strerror()
; *
; * DESCRIPTION
; *
; * The curl_share_strerror function may be used to turn a CURLSHcode value
; * into the equivalent human readable error string.  This is useful
; * for printing meaningful error messages.
; */
;~ CURL_EXTERN const char *curl_share_strerror(CURLSHcode);
Func _curl_share_strerror($code)
	Local $aResult = DllCall($ghLIBCURLdll, "str:cdecl", "curl_share_strerror", 'int', $code)
	If @error Then Return SetError(1, 0, '')
	Return $aResult[0]
EndFunc

;/*
; * NAME curl_easy_pause()
; *
; * DESCRIPTION
; *
; * The curl_easy_pause function pauses or unpauses transfers. Select the new
; * state by setting the bitmask, use the convenience defines below.
; *
; */
;~ CURL_EXTERN CURLcode curl_easy_pause(CURL *handle, int bitmask);
Func _curl_easy_pause($handle, $bitmask)
	Local $aResult = DllCall($ghLIBCURLdll, "int:cdecl", "curl_easy_pause", 'ptr', $handle, 'int', $bitmask)
	If @error Then Return SetError(1, 0, $CURL_LAST)
	Return $aResult[0]
EndFunc

Global Const $CURLPAUSE_RECV      = 1
Global Const $CURLPAUSE_RECV_CONT = (0)

Global Const $CURLPAUSE_SEND      = BitShift(1, -2)
Global Const $CURLPAUSE_SEND_CONT = (0)

Global Const $CURLPAUSE_ALL       = BitOR($CURLPAUSE_RECV, $CURLPAUSE_SEND)
Global Const $CURLPAUSE_CONT      = BitOR($CURLPAUSE_RECV_CONT, $CURLPAUSE_SEND_CONT)

;~ #ifdef  __cplusplus
;~ }
;~ #endif

;/* unfortunately, the easy.h and multi.h include files need options and info
;  stuff before they can be included!; */
#include "easy.au3" ;/* nothing in curl is fun without the easy stuff; */
#include "multi.au3"
#cs
;/* the typechecker doesn't work in C++ (yet); */
#if defined(__GNUC__) && defined(__GNUC_MINOR__) && \
    ((__GNUC__ > 4) || (__GNUC__ == 4 && __GNUC_MINOR__ >= 3)) && \
    !defined(__cplusplus) && !defined(CURL_DISABLE_TYPECHECK)
#include "typecheck-gcc.h"
#else
#if defined(__STDC__) && (__STDC__ >= 1)
;/* This preprocessor magic that replaces a call with the exact same call is
   only done to make sure application authors pass exactly three arguments
   to these functions.; */
Global Const $curl_easy_setopt(handle,opt,param) curl_easy_setopt(handle,opt,param)
Global Const $curl_easy_getinfo(handle,info,arg) curl_easy_getinfo(handle,info,arg)
Global Const $curl_share_setopt(share,opt,param) curl_share_setopt(share,opt,param)
Global Const $curl_multi_setopt(handle,opt,param) curl_multi_setopt(handle,opt,param)
#endif ;/* __STDC__ >= 1; */
#endif ;/* gcc >= 4.3 && !__cplusplus; */
#ce

;#endif ;/* __CURL_CURL_H; */

;===============================================================================
;
; Function Name:   __CURL_PtrStringLen
; Description::    Gets length for a string by pointer
; Parameter(s):    $ptr       - Pointer to String
;                  $IsUniCode - Is a unicode string default. False
; Requirement(s):  libmysql.dll
; Return Value(s): Length of the string
; Author(s):       Prog@ndy
;
;===============================================================================
;
Func __CURL_PtrStringLen($ptr, $IsUniCode = False)
	Local $UniCodeFunc = ""
	If $IsUniCode Then $UniCodeFunc = "W"
	Local $Ret = DllCall("kernel32.dll", "int", "lstrlen" & $UniCodeFunc, "ptr", $ptr)
	If @error Then Return SetError(1, 0, -1)
	Return $Ret[0]
EndFunc   ;==>__CURL_PtrStringLen

;===============================================================================
;
; Function Name:   __CURL_PtrStringRead
; Description::    Reads a string by pointer
; Parameter(s):    $ptr       - Pointer to String
;                  $IsUniCode - Is a unicode string default. False
; Requirement(s):  libmysql.dll
; Return Value(s): read string
; Author(s):       Prog@ndy
;
;===============================================================================
;
Func __CURL_PtrStringRead($ptr, $IsUniCode = False, $StringLen = -1)
	Local $UniCodeString = ""
	If $IsUniCode Then $UniCodeString = "W"
	If $StringLen < 1 Then $StringLen = __CURL_PtrStringLen($ptr, $IsUniCode)
	If $StringLen < 1 Then Return SetError(1, 0, "")
	Local $struct = DllStructCreate($UniCodeString & "char[" & ($StringLen + 1) & "]", $ptr)
	Return DllStructGetData($struct, 1)
EndFunc   ;==>__CURL_PtrStringRead
